﻿Imports System
Imports System.IO
Imports System.Text
Imports System.Globalization
Imports System.Drawing.Drawing2D
Imports System.Drawing.Imaging
Imports System.Drawing.Printing
Imports System.Drawing.Image

REM *****************************************************************
REM *  Definition aller systemübergreifenden Variablen              *
REM *****************************************************************
Public Class Cls_00_Def

    REM *----------------------------------------------------------------*
    REM *  Systemvariablen                                               *
    REM *----------------------------------------------------------------*
    Public ReadOnly Preview As New PreviewHandler

    Public Shared ci As New CultureInfo("de-DE")
    Public Shared dt As DateTime = DateTime.Now
    Public Shared str_AktJahr As String
    Public Shared str_AktMon As String
    Public Shared str_AktTag As String
    Public Shared str_AktHH As String
    Public Shared str_AktMM As String
    Public Shared str_AktSS As String
    Public Shared str_AktDat As String
    Public Shared str_AktDatP As String
    Public Shared str_AktDat1 As String
    Public Shared str_LW_INI As String = "D:\"
    Public Shared str_Path_1 As String
    Public Shared str_Path_2 As String
    Public Shared str_Directory As String
    Public Shared str_PicDirectory As String
    Public Shared str_DBName As String
    Public Shared str_DBPfad1 As String
    Public Shared str_DBPfad2 As String
    Public Shared str_DBPfad3 As String
    Public Shared str_PfadGM As String
    Public Shared str_FileGM As String
    Public Shared str_PfadGed As String
    Public Shared str_FileGed As String
    Public Shared str_Sort As String
    Public Shared str_Ged As String
    Public Shared str_Ged1 As String
    Public Shared str_Ged2 As String
    Public Shared str_Ged3 As String
    Public Shared int_GedAnz As Integer
    Public Shared str_Create As String
    Public Shared str_IN1() As String
    Public Shared int_in1 As Integer
    Public Shared str_Ged_TAG As String
    Public Shared str_Ged_Fil As String
    Public Shared str_Ged_Daten As String
    Public Shared str_Ged_Satz As String
    Public Shared int_Ged_Anz As Integer
    Public Shared int_Akt_ID As Integer = 0

    'Public Shared InvalDate As InvalidCastException

    Public Shared dbProv As String
    Public Shared dbGM As String
    Public Shared con As New OleDb.OleDbConnection
    Public Shared conGM As New OleDb.OleDbConnection

    'Public Shared img_Del As Image = My.Resources.Del1
    'Public Shared openFD As New OpenFileDialog
    Public Shared myStream As Stream
    Public Shared FileName As String
    Public Shared str_FileName As String
    Public Shared Img_Pers As Image

    Public Shared CStyle As System.Windows.Forms.DataGridViewCellStyle
    Public Shared mySelect As New OleDb.OleDbCommand
    Public Shared mySelect1 As New OleDb.OleDbCommand
    Public Shared mySelectGM As New OleDb.OleDbCommand
    Public Shared myAdapter As New OleDb.OleDbDataAdapter
    Public Shared myDataSet As New DataSet
    Public Shared myDataView As New DataView
    Public Shared scA_Orte As New AutoCompleteStringCollection
    Public Shared scA_Konf As New AutoCompleteStringCollection
    Public Shared scA_Date As New AutoCompleteStringCollection
    Public Shared scA_Nam1 As New AutoCompleteStringCollection
    Public Shared scA_Nam2 As New AutoCompleteStringCollection
    Public Shared scA_Tod As New AutoCompleteStringCollection
    Public Shared scA_Beruf As New AutoCompleteStringCollection
    Public Shared scA_Q1 As New AutoCompleteStringCollection
    Public Shared scA_Q2 As New AutoCompleteStringCollection
    Public Shared scA_Q3 As New AutoCompleteStringCollection
    'Public Shared myTable As New DataTable

    Public Shared myNull As Boolean
    Public Shared myJa As Boolean = True
    Public Shared myNein As Boolean = False
    Public Shared DB_Anz As Integer

    Public Shared str_Msg As String
    Public Shared str_Titel As String
    Public Shared style As MsgBoxStyle
    Public Shared response As MsgBoxResult

    Public Shared str_ini As String
    Public Shared str_NM99 As String
    Public Shared str_X As String = "  X"
    Public Shared str_XNeu As String

    Public Shared int_Total_Error As Integer = 0
    REM *----------------------------------------------------------------*
    REM *  Programmkonstanten                                            *
    REM *----------------------------------------------------------------*
    Public Shared str_Prog_Titel As String = "Ahnenverwaltung"
    Public Shared str_Prog_Name As String = "NM-Ahnen"
    Public Shared str_Prog_Rel As String = "Rel: 1.0"
    Public Shared str_Copyright As String = "(c) Norbert Mende, 2017, ff"
    Public Shared int_Sprache As Integer
    Public Shared str_DokPfad As String = ""

    REM *----------------------------------------------------------------*
    REM *  Variablen für Größenbestimmung der Controls,                  *
    REM *  abhängig von der Bildschirmauflösung                          *
    REM *----------------------------------------------------------------*
    Public Shared int_Screen_W As Integer = System.Windows.Forms.Screen.PrimaryScreen.WorkingArea.Width()
    Public Shared int_Screen_H As Integer = System.Windows.Forms.Screen.PrimaryScreen.WorkingArea.Height()

    Public Shared int_SC_FormW As Integer
    Public Shared int_SC_FormH As Integer
    Public Shared int_Navi_Height_Big As Integer = 70
    Public Shared int_Navi_Height_Low As Integer = 42
    Public Shared int_Navi_Height As Integer

    Public Shared int_Navi_Width As Integer

    Public Shared int_Menue_Height As Integer = 25
    Public Shared int_Menue_Width As Integer

    Public Shared int_GridZeileH_Big As Integer = 22
    Public Shared int_GridZeileH_Low As Integer = 16
    Public Shared int_GridZeileH As Integer

    Public Shared int_Navi_Button_Height As Integer = 35
    Public Shared int_Navi_Button_Width As Integer = 35

    Public Shared int_pan_Height_Big As Integer = 50
    Public Shared int_pan_Height_Low As Integer = 30
    Public Shared int_pan_Height As Integer
    Public Shared int_pan_Width As Integer

    Public Shared int_RB_Loc_Big As Integer = 18
    Public Shared int_RB_Loc_Low As Integer = 10
    Public Shared int_RB_Loc As Integer

    Public Shared int_Stst_Height As Integer = 25
    Public Shared int_Stst_Width As Integer

    Public Shared int_pan_01 As Integer
    Public Shared int_Vater_Height As Integer
    Public Shared int_Mutter_Height As Integer
    Public Shared int_Listbox_Gesamt_Height As Integer
    Public Shared int_lbx_Ehe_Height As Integer
    Public Shared int_lbx_Kinder_Height As Integer
    Public Shared int_lbx_Geschw_Height As Integer
    Public Shared int_lbx_Paten_Height As Integer
    Public Shared int_lbx_Zeugen_Height As Integer
    Public Shared int_NM_FeldNr As Integer
    Public Shared int_GedFound As Integer = 0
    Public Shared dbl_GedID As Double = 0

    Public Shared int_bt_OK_Height As Integer = 40
    Public Shared int_bt_OK_Width As Integer = 40

    Public Shared int_tb1_Width As Integer
    Public Shared int_tb1_Height As Integer

    Public Shared int_tb1_SubWidth As Integer
    Public Shared int_tb1_SubHeight As Integer

    Public Shared int_Grid_W As Integer
    Public Shared int_Grid_H As Integer

    Public Shared int_spc1_width As Integer
    Public Shared int_spc1_height As Integer

    Public Shared int_spc1_pan1_width As Integer
    Public Shared int_spc1_pan1_height As Integer

    Public Shared int_spc1_pan2_width As Integer
    Public Shared int_spc1_pan2_height As Integer

    Public Shared int_SplitDisW As Integer
    Public Shared int_SplitDisP As Integer = 12

    Public Shared int_BordW As Integer = 3

    REM *----------------------------------------------------------------*
    REM *  Variable für Label und Textfelder                             *
    REM *----------------------------------------------------------------*
    Public Shared col_Ant As Color = Color.AntiqueWhite
    Public Shared col_Back As Color = Color.Cornsilk
    Public Shared col_lbl As Color = Color.NavajoWhite
    Public Shared col_txt As Color = Color.White
    Public Shared col_Quelle As Color = Color.Gainsboro
    Public Shared col_btn As Color = Color.FromArgb(197, 215, 127)
    Public Shared col_btn_OK As Color = Color.PaleGreen
    Public Shared col_btn_NO As Color = Color.Tomato
    Public Shared col_info1 As Color = Color.PaleGreen
    Public Shared col_info2 As Color = Color.Crimson
    Public Shared col_Grid1 As Color = Color.LemonChiffon
    Public Shared col_Grid2 As Color = Color.Gold
    Public Shared col_btn_Mouse As Color = Color.Gold
    Public Shared col_tx_Mann As Color = Color.Blue
    Public Shared col_tx_Frau As Color = Color.Red
    Public Shared col_TabPositiv As Color = Color.Black
    Public Shared col_QInfo As Color = Color.WhiteSmoke
    Public Shared col_Pers As Color = Color.DarkGreen
    Public Shared col_tx_Geschl As Color

    Public Shared int_txt_Height_Big As Integer = 18
    Public Shared int_txt_Height_Low As Integer = 12
    Public Shared int_txt_Height As Integer

    Public Shared int_txt2_Height_Big As Integer = 18
    Public Shared int_txt2_Height_Low As Integer = 12
    Public Shared int_txt2_Height As Integer

    Public Shared int_lbl_Width As Integer = 80
    Public Shared int_lbl2_Width As Integer = 80

    Public Shared int_lbl_Height_Big As Integer = 20
    Public Shared int_lbl_Height_Low As Integer = 14
    Public Shared int_lbl_Height As Integer

    Public Shared int_lbl2_Height_Big As Integer = 20
    Public Shared int_lbl2_Height_Low As Integer = 14
    Public Shared int_lbl2_Height As Integer

    Public Shared int_txt_Width As Integer = 400
    Public Shared int_txt1_Width As Integer = 80
    Public Shared int_txt2_Width As Integer = 160
    Public Shared int_txt3_width As Integer = 240
    Public Shared int_txt4_Width As Integer = 200
    Public Shared int_txt5_Width As Integer = 300
    Public Shared int_txt6_Width As Integer = 300

    Public Shared int_DatTT_Width As Integer = 20
    Public Shared int_DatMM_Width As Integer = 20
    Public Shared int_DatJJ_Width As Integer = 40
    Public Shared int_DatP_Width As Integer = 4

    Public Shared int_Dat_Height_Big As Integer = 18
    Public Shared int_Dat_Height_Low As Integer = 12
    Public Shared int_Dat_Height As Integer

    Public Shared int_gbx_Width As Integer = 400

    Public Shared int_gbx_Height_Big As Integer = 50
    Public Shared int_gbx_Height_Low As Integer = 30
    Public Shared int_gbx_Height As Integer

    Public Shared int_gbx91_Width As Integer = 600

    Public Shared int_gbx91_Height_Big As Integer = 200
    Public Shared int_gbx91_Height_Low As Integer = 120
    Public Shared int_gbx91_Height As Integer
    Public Shared int_Para_Tab_Width As Integer
    Public Shared int_dgv_SizeB As Integer
    Public Shared int_dgv_SizeH As Integer

    Public Shared int_lbx_Width As Integer = 400
    Public Shared int_lbx_Width_Rechts As Integer = 500

    Public Shared int_lbx_Height_Big As Integer = 50
    Public Shared int_lbx_Height_Low As Integer = 30
    Public Shared int_lbx_Height As Integer

    Public Shared int_rbt01_Width As Integer
    Public Shared int_rbt01_Height As Integer

    Public Shared int_tab_Width As Integer = 450

    Public Shared int_tab_Height_Big As Integer = 400
    Public Shared int_tab_Height_Low As Integer = 300
    Public Shared int_tab_Height As Integer

    Public Shared int_gbx3_Width As Integer = 400
    Public Shared int_gbx3_Height_Big As Integer = 400
    Public Shared int_gbx3_Height_Low As Integer = 240
    Public Shared int_gbx3_Height As Integer

    Public Shared int_rtx_Text_Height As Integer = 500

    Public Shared int_x As Integer = 10
    Public Shared int_y As Integer = 10
    Public Shared int_Pos_x As Integer
    Public Shared int_Pos_x2 As Integer
    Public Shared int_Pos_y As Integer
    Public Shared int_Pos_Y2 As Integer
    Public Shared int_Zeil As Integer

    Public Shared int_ZDiff_Big As Integer = 3
    Public Shared int_ZDiff_Low As Integer = 2
    Public Shared int_ZDiff As Integer

    Public Shared int_BDiff_Big As Integer = 3
    Public Shared int_BDiff_Low As Integer = 2
    Public Shared int_BDiff As Integer
    Public Shared int_SelCol As Integer
    Public Shared int_SelPara As Integer = 0

    REM *------------------------------------------------------------*
    REM *  Zähler für Import-/Export-Routinen                        *
    REM *------------------------------------------------------------*
    Public Shared int_Imp01 As Integer
    Public Shared int_Imp02 As Integer
    Public Shared int_Imp03 As Integer
    Public Shared int_Imp04 As Integer
    Public Shared int_Imp05 As Integer
    Public Shared int_Imp06 As Integer
    Public Shared int_Imp07 As Integer
    Public Shared int_Imp08 As Integer
    Public Shared int_Imp09 As Integer
    Public Shared int_Imp10 As Integer
    Public Shared int_Imp11 As Integer

    REM *------------------------------------------------------------*
    REM *  Koordinaten für Suchmaske                                 *
    REM *------------------------------------------------------------*
    Public Shared int_91_Height As Integer
    Public Shared int_91_Width As Integer

    Public Shared int_Zeig_Pers As Double
    Public Shared int_Monitor As Integer = 1
    Public Shared int_Screen_x As Integer
    Public Shared int_Screen_y As Integer

    Public Shared font_Header_Person = New System.Drawing.Font("Calibri", 12.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))

    Public Shared font_Foretext_Big = New System.Drawing.Font("Calibri", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Public Shared font_Foretext_1024 = New System.Drawing.Font("Calibri", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Public Shared font_Foretext
    Public Shared font_Foretext_Bold_Big = New System.Drawing.Font("Calibri", 10.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Public Shared font_Foretext_Bold_1024 = New System.Drawing.Font("Calibri", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Public Shared font_Foretext_Bold

    Public Shared font_Label_Big = New System.Drawing.Font("Calibri", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Public Shared font_Label_1024 = New System.Drawing.Font("Calibri", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
    Public Shared font_Label
    Public Shared font_Liste = New System.Drawing.Font("Calibri", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))

    Public Shared dgv_M = New DataGridViewCellStyle
    Public Shared dgv_F = New DataGridViewCellStyle

    Public Shared dbl_ID As Double
    Public Shared dbl_Max As Double
    Public Shared dbl_Max_ID As Double
    Public Shared dbl_Max_T04 As Double
    Public Shared dbl_Beruf_Max As Double
    Public Shared dbl_Pers_ID As Double
    Public Shared dbl_Sel_ID As Double
    Public Shared dbl_T04_Max As Double
    Public Shared dbl_T04_Max1 As Double
    Public Shared dbl_T41_ID As Double
    Public Shared dbl_Tmp As Double
    Public Shared dbl_PosS As Double
    Public Shared dbl_a04_ID As Double
    Public Shared dbl_Ehe41 As Double
    Public Shared int_Max_LFD As Integer
    Public Shared int_Anz_Adr As Integer
    Public Shared dbl_x As Double
    Public Shared dbl_Vater As Double
    Public Shared dbl_Mutter As Double
    Public Shared dbl_Last_ID As Double
    Public Shared dbl_First_ID As Double

    Public Shared int_Anz As Integer

    Public Shared int_i01 As Integer
    Public Shared int_i02 As Integer
    Public Shared int_i03 As Integer
    Public Shared int_i04 As Integer
    Public Shared int_T1 As Integer
    Public Shared int_T2 As Integer
    Public Shared int_T3 As Integer
    Public Shared int_T4 As Integer
    Public Shared int_T5 As Integer

    Public Shared int_GOrt As Integer
    Public Shared int_TOrt As Integer
    Public Shared int_SOrtx As Integer
    Public Shared int_BOrt As Integer
    Public Shared int_EOrt1 As Integer
    Public Shared int_EOrt2 As Integer
    Public Shared int_XOrt As Integer
    Public Shared int_Sel_Event As Integer
    Public Shared int_Sel_Ort As Integer

    Public Shared int_Para_x As Integer
    Public Shared int_Para_y As Integer
    Public Shared int_Tab_x As Integer

    Public Shared int_Stat_H1 As Integer = 22
    Public Shared int_Stat_H2 As Integer = 17

    Public Shared str_Insert As String
    Public Shared str_Where As String
    Public Shared str_Where1 As String
    Public Shared str_Where2 As String
    Public Shared str_Order As String
    Public Shared str_HFeld As String
    Public Shared str_HDat1 As String
    Public Shared str_HDat2 As String
    Public Shared str_HDat3 As String
    Public Shared str_Aufgabe As String
    Public Shared str_DatV1 As String
    Public Shared str_DatV2 As String
    Public Shared str_SearchX As String
    Public Shared int_Sort As Integer = 0
    Public Shared SortDir As String = ""
    Public Shared str_Sort_Search As String = ""
    Public Shared str_Search_Header As String = "NM_Ahnen_Suche"
    Public Shared str_Sel_Anz = ""
    Public Shared int_Info_Type As Integer = 0
    Public Shared str_Info_00 = ""
    Public Shared str_Info_01 As String = "Basis-Daten werden geladen - bin gleich bereit"
    Public Shared str_Info_02 As String = "etwas Geduld - Daten werden aufbereitet"

    Public Shared int_Merk_Orte1 As Integer = 0
    Public Shared str_TX_Ort1 As String
    Public Shared str_TX_Ort2 As String
    Public Shared str_TX_Ort3 As String

    Public Shared lng_ID() As Long
    Public Shared lng_Pers As Long

    Public Shared lng_Ehe_ID() As Long
    Public Shared int_Ehe As Integer
    Public Shared int_Pos_E As Integer
    Public Shared int_TZ_Typ As Integer
    Public Shared lng_HID As Long = 0

    Public Shared lng_Ges_ID() As Long
    Public Shared int_Ges_Typ() As Integer
    Public Shared int_Ges As Integer
    Public Shared int_Pos_G As Integer

    Public Shared lng_Kind_ID() As Long
    Public Shared int_Kind As Integer
    Public Shared int_Pos_K As Integer

    Public Shared lng_Pate_ID() As Long
    Public Shared int_Pate As Integer
    Public Shared int_Pos_P As Integer

    Public Shared lng_Pate1_ID() As Long
    Public Shared int_Pate1 As Integer
    Public Shared int_Pos_P1 As Integer

    Public Shared lng_Zeuge_ID() As Long
    Public Shared int_Zeuge As Integer
    Public Shared int_Pos_Z As Integer
    Public Shared int_Adr As Integer
    Public Shared int_Adr_Akt As Integer
    Public Shared int_Lfd As Integer
    Public Shared int_BerufN As Integer

    Public Shared lng_Zeuge1_ID() As Long
    Public Shared int_Zeuge1 As Integer
    Public Shared int_Pos_Z1 As Integer

    Public Shared lng_Zeuge2_ID() As Long
    Public Shared int_Zeuge2 As Integer
    Public Shared int_Pos_Z2 As Integer

    Public Shared lng_Beruf_ID() As Long
    Public Shared int_Beruf As Integer
    Public Shared int_Pos_B As Integer
    Public Shared int_Anz_Komm As Integer

    Public Shared int_Merk_Plausi As Integer

    Public Shared int_Merk_Neu As Integer = 1
    Public Shared int_Merk_Tab_Grund As Integer = 1
    Public Shared int_Merk_Tab_Ehe As Integer
    Public Shared int_Merk_Tab_Taufe As Integer
    Public Shared int_Merk_Tab_Beerd As Integer
    Public Shared int_Merk_Tab_Beruf As Integer
    Public Shared int_Merk_Tab_Text As Integer
    Public Shared int_Merk_Tab_Anschr As Integer
    Public Shared int_Merk_Tab_Paten As Integer
    Public Shared int_Merk_Tab_Quelle As Integer
    Public Shared int_Merk_First As Integer
    Public Shared int_Merk_Search As Integer
    Public Shared int_Merk_Tab As Integer
    Public Shared int_Merk_Sel As Integer
    Public Shared int_Merk_Where As Integer
    Public Shared int_Merk_STyp As Integer
    Public Shared int_Merk_Plausi_Search As Integer
    Public Shared int_lby_Pos As Integer
    Public Shared int_Merk_Bild As Integer
    Public Shared int_Merk_vgl As Integer
    Public Shared int_Merk_Import As Integer
    Public Shared int_Merk_Liste As Integer = 0
    Public Shared int_Merk_SortError As Integer = 0
    Public Shared dt_Date As Date
    Public Shared int_Para_Typ As Integer
    Public Shared int_SubTyp As Integer
    Public Shared int_Para_i1 As Integer
    Public Shared int_Para_i2 As Integer
    Public Shared int_Para_i3 As Integer
    Public Shared str_Para_tx1 As String
    Public Shared str_Para_tx2 As String
    Public Shared str_Para_tx3 As String
    Public Shared int_Para_Feld As Integer
    Public Shared int_P1 As Integer
    Public Shared int_P2 As Integer
    Public Shared int_P3 As Integer
    Public Shared str_t1 As String
    Public Shared str_t2 As String
    Public Shared str_t3 As String
    Public Shared int_High_Datum As Integer
    Public Shared int_High_Konf As Integer
    Public Shared int_High_Para As Integer
    Public Shared int_Mess_Retour As Integer

    Public Shared int_FL As Integer = 100                       ' Maximale Feldlänge (Plausi)

    Public Shared int_Sel_Tab As Integer = 0
    Public Shared int_Sel_TabX As Integer = 0
    Public Shared int_Sel_TabY As Integer = 0

    Public Shared tab_Beruf_ID() As Double
    Public Shared tab_Beruf_Bez() As String

    Public Shared tab_Reiter() As String

    Public Shared int_AnzDB As Integer
    Public Shared temp_ID() As Double
    Public Shared str_DBS_a00 As String
    Public Shared str_DBD_a00 As String
    Public Shared str_DBS_a01 As String
    Public Shared str_DBD_a01 As String
    Public Shared str_DBS_a02 As String
    Public Shared str_DBD_a02 As String
    Public Shared str_DBS_a03 As String
    Public Shared str_DBD_a03 As String
    Public Shared str_DBS_a04 As String
    Public Shared str_DBD_a04 As String
    Public Shared str_DBS_a05 As String
    Public Shared str_DBD_a05 As String
    Public Shared str_DBS_a06 As String
    Public Shared str_DBD_a06 As String
    Public Shared str_DBS_a07 As String
    Public Shared str_DBD_a07 As String
    Public Shared str_DBS_a08 As String
    Public Shared str_DBD_a08 As String
    Public Shared str_DBS_a09 As String
    Public Shared str_DBD_a09 As String
    Public Shared str_DBS_t01 As String
    Public Shared str_DBD_t01 As String
    Public Shared str_DBS_t02 As String
    Public Shared str_DBD_t02 As String
    Public Shared str_DBS_t03 As String
    Public Shared str_DBD_t03 As String
    Public Shared str_DBS_t04 As String
    Public Shared str_DBD_t04 As String
    Public Shared str_DBS_t041 As String
    Public Shared str_DBD_t041 As String
    Public Shared str_DBS_t05 As String
    Public Shared str_DBD_t05 As String
    Public Shared str_DBS_t06 As String
    Public Shared str_DBD_t06 As String
    Public Shared str_DBS_t07 As String
    Public Shared str_DBD_t07 As String
    Public Shared str_DBS_t08 As String
    Public Shared str_DBD_t08 As String
    Public Shared str_DBS_t09 As String
    Public Shared str_DBD_t09 As String
    Public Shared str_DBD_t10 As String
    Public Shared str_DBS_t10 As String
    Public Shared str_DBD_t11 As String
    Public Shared str_DBS_t11 As String
    Public Shared str_DBS_t12 As String
    Public Shared str_DBD_t12 As String
    Public Shared str_DBS_t13 As String
    Public Shared str_DBD_t13 As String
    Public Shared str_DBS_t21 As String
    Public Shared str_DBD_t21 As String
    Public Shared str_DBS_t31 As String
    Public Shared str_DBD_t31 As String
    Public Shared str_DBS_t32 As String
    Public Shared str_DBD_t32 As String
    Public Shared str_DBS_t33 As String
    Public Shared str_DBD_t33 As String
    Public Shared str_DBS_t77 As String
    Public Shared str_DBD_t77 As String
    Public Shared str_DBS_t88 As String
    Public Shared str_DBD_t88 As String
    Public Shared str_DBS_t92 As String
    Public Shared str_DBD_t92 As String
    Public Shared str_DBS_t99 As String
    Public Shared str_DBD_t99 As String
    Public Shared str_DBA2 As String

    Public Shared str_t91_Head(34) As String

    Public Shared str_UString As String
    Public Shared str_UString1 As String

    Public Shared int_AnzPara As Integer
    Public Shared str_Para_DA() As String
    Public Shared int_Para_DA() As Integer
    Public Shared int_Para_DB As Integer
    Public Shared int_ID As Integer

    Public Shared int_Konf As Integer = 0
    Public Shared int_GDat_Art As Integer = 0
    Public Shared int_SDat_Art As Integer = 0
    Public Shared int_TDat_Art As Integer = 0
    Public Shared int_FDat_Art As Integer = 0
    Public Shared int_EDat1_Art As Integer = 0
    Public Shared int_EDat2_Art As Integer = 0
    Public Shared int_EDat3_Art As Integer = 0
    Public Shared int_BDat_Art As Integer = 0
    Public Shared str_EFeld() As String

    Public Shared str_Konf As String
    Public Shared str_GDat_Art As String
    Public Shared str_SDat_Art As String
    Public Shared str_TDat_Art As String
    Public Shared str_FDat_Art As String
    Public Shared str_EDat1_Art As String
    Public Shared str_EDat2_Art As String
    Public Shared str_EDat3_Art As String
    Public Shared str_BDat_Art As String

    Public Shared int_AnzKonf As Integer
    Public Shared int_AnzNam1 As Integer
    Public Shared int_AnzNam2 As Integer
    Public Shared int_AnzTod As Integer
    Public Shared int_AnzBeruf As Integer
    Public Shared str_Para_Konf_Bez() As String
    Public Shared str_Para_Konf_Text() As String
    Public Shared int_Para_Konf() As Integer
    Public Shared str_Para_Nam1_Text() As String
    Public Shared str_Para_Nam2_Text() As String
    Public Shared str_Para_Tod_Text() As String
    Public Shared int_Para_Tod_Anz() As Integer
    Public Shared str_Para_Beruf_Text() As String
    Public Shared int_Para_Anzahl() As Integer
    Public Shared int_Para_Anzahl_Tod() As Integer
    Public Shared int_Para_Vorname_Anz() As Integer
    Public Shared int_Para_Konf_DB As Integer
    Public Shared int_Anz_Name(,) As Integer
    Public Shared str_Name() As String
    Public Shared int_Para_Nam1_Nr() As Integer
    Public Shared int_Para_Nam2_Nr() As Integer
    Public Shared int_Para_Tod_Nr() As Integer
    Public Shared int_Para_Ort_Nr() As Integer
    Public Shared int_AnzOrte As Integer
    Public Shared str_Para_Ort1_Bez() As String
    Public Shared str_Para_Ort2_Bez() As String
    Public Shared str_Para_Ort3_Bez() As String
    Public Shared str_Para_Ort_Anz0() As String
    Public Shared str_Para_Ort_Anz1() As String
    Public Shared str_Para_Ort_Anz2() As String
    Public Shared str_Para_Ort_Anz3() As String
    Public Shared str_Para_Ort_Anz4() As String
    Public Shared str_Para_Ort_Anz5() As String
    Public Shared str_Para_Ort_Anz7() As String
    Public Shared str_Para_Ort_Anz6() As String
    Public Shared int_Para_Orte_DB As Integer
    Public Shared int_a04_PID() As Integer
    Public Shared int_a04_Event() As Integer
    Public Shared str_t08_Datum() As String
    Public Shared str_Sel_Event As String
    Public Shared str_Tab_Event(7) As String

    Public Shared int_PicZaehl As Integer
    Public Shared int_AnzPic As Integer
    Public Shared int_AnzQ1 As Integer
    Public Shared int_AnzQ2 As Integer
    Public Shared int_AnzQ3 As Integer
    Public Shared str_PicBez() As String
    Public Shared str_PicName() As String
    Public Shared int_PicOK() As Integer
    Public Shared str_DateiEndung As String
    Public Shared str_Dat_H As String
    Public Shared str_Tab As String
    Public Shared str_Pfad_Pic As String
    Public Shared str_PersPic As String
    Public Shared int_Merk_Vater_Update As Double
    Public Shared int_Vater_Alt As Double
    Public Shared int_Mutter_Alt As Double
    Public Shared int_Merk_Mutter_Update As Double
    Public Shared int_Merk_VUP As Integer = 0
    Public Shared int_Merk_MUP As Integer = 0

    Public Shared lg_ID() As Double

    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für Quellenverwaltung                         *
    REM *------------------------------------------------------------*
    Public Shared int_QuellMask As Integer = 0
    Public Shared iQ_Event As Integer
    Public Shared int_Event_OK(12) As Integer
    Public Shared t13_Tab_ID(12) As Integer
    Public Shared p_str_Quelle(12) As String
    Public Shared str_QuellenTyp(12) As String
    Public Shared p_str_DatQ As String
    Public Shared p_int_Event As Integer
    Public Shared p_int_Ort As Integer
    Public Shared p_int_KB As Integer
    Public Shared p_str_QuellText As String
    Public Shared p_str_Detail As String
    Public Shared p_str_Bem As String
    Public Shared p_int_Q1 As Integer
    Public Shared p_int_Q2 As Integer
    Public Shared p_int_Q3 As Integer
    Public Shared p_str_Q1H As String
    Public Shared p_str_Q2H As String
    Public Shared p_str_Q3H As String
    Public Shared p_str_Q4H As String
    Public Shared p_str_Q5H As String
    Public Shared p_str_Q6H As String

    Public Shared str_Q1() As String
    Public Shared int_Q2_Typ() As Integer
    Public Shared int_Q1_Pos() As Integer
    Public Shared int_Q2_Pos() As Integer
    Public Shared int_Q3_Pos() As Integer
    Public Shared int_Q3_Ort() As Integer
    Public Shared int_iTyp As Integer
    Public Shared str_Q1K() As String
    Public Shared str_Q2() As String
    Public Shared str_Q3() As String
    Public Shared int_Sel_Q1 As Integer
    Public Shared int_Sel_Q2 As Integer
    Public Shared int_Sel_Q3 As Integer
    Public Shared int_Sel_t31 As Integer
    Public Shared int_Sel_t32 As Integer
    Public Shared int_Sel_t33 As Integer
    Public Shared int_Sel_Typ As Integer
    Public Shared int_Sel_t34 As Integer
    Public Shared str_Q1_Bez As String
    Public Shared str_Q1_Kurz As String
    Public Shared str_Sel_Kurz As String
    Public Shared str_Sel_Detail As String
    Public Shared str_Sel_Ort As String
    Public Shared str_Quelltext As String
    Public Shared str_Q2_Ort As String
    Public Shared str_Q2_Bem As String
    Public Shared str_Q3_Detail As String
    Public Shared str_Q3_Bem As String
    Public Shared int_QuellenTyp As Integer = 0
    Public Shared str_Sel31_Bez
    Public Shared str_Sel32_Bez
    Public Shared str_Sel33_Bez
    Public Shared int_QVersion As Integer = 0
    Public Shared str_QX1 As String
    Public Shared str_QX2 As String
    Public Shared str_QX3 As String
    Public Shared str_QX4 As String
    Public Shared str_QXNeu As String
    Public Shared int_t13_Event As Integer
    Public Shared int_t13_Kb As Integer
    Public Shared int_t13_Ort As Integer
    Public Shared str_Q_Bemerk As String
    Public Shared str_Q_Datum As String
    Public Shared dbl_t13_ID As Double
    Public Shared int_EVI() As Integer
    Public Shared int_EV() As Integer
    Public Shared str_EV() As String
    Public Shared str_ED() As String
    Public Shared int_PicDir As Integer
    Public Shared int_Pic_OK As Integer
    Public Shared int_Find As Integer = 0

    Public Shared Filepdf As String
    Public Shared int_PDFZeigen As Integer = 0


    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für Lesen Infodaten                           *
    REM *------------------------------------------------------------*
    Public Shared int_Info01 As Integer = 0
    Public Shared int_Info02 As Integer = 0
    Public Shared p_akt_Komm As String
    Public Shared str_Info01 As String
    Public Shared str_InfoTyp As String
    Public Shared int_Merk_info As Integer = 0

    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für Altersermittlung                          *
    REM *------------------------------------------------------------*
    Public Shared int_Old1_J As Integer
    Public Shared int_Old1_M As Integer
    Public Shared int_Old1_T As Integer
    Public Shared int_Old2_J As Integer
    Public Shared int_Old2_M As Integer
    Public Shared int_Old2_T As Integer
    Public Shared int_Diff_J As Integer
    Public Shared int_Diff_M As Integer
    Public Shared int_Diff_T As Integer

    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für Plausiprüfungen                           *
    REM *------------------------------------------------------------*
    Public Shared int_Delta_Vater_Min As Integer = 15
    Public Shared int_Delta_Mutter_Min As Integer = 15
    Public Shared int_Delta_Ehe_Min As Integer = 18
    Public Shared int_Delta_Pate_Min As Integer = 15
    Public Shared int_Delta_Zeuge_Min As Integer = 20

    Public Shared int_Delta_Vater_Max As Integer = 85
    Public Shared int_Delta_Mutter_Max As Integer = 55
    Public Shared int_Delta_Ehe_Max As Integer = 85
    Public Shared int_Delta_Pate_Max As Integer = 85
    Public Shared int_Delta_Zeuge_Max As Integer = 85

    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für Aufgabenliste                             *
    REM *------------------------------------------------------------*
    Public Shared a_dbl_t99 As Double
    Public Shared a_int_Lfd As Integer
    Public Shared a_str_Name As String
    Public Shared a_str_GebName As String
    Public Shared a_str_Vorname As String
    Public Shared a_str_GDat As String
    Public Shared a_str_TI As String
    Public Shared a_str_Aktion As String

    Public Shared a_dbl_t88 As Double
    Public Shared a_int_t88_Feld As Integer
    Public Shared a_int_t88_Tab As Integer
    Public Shared a_str_t88_Datum As String
    Public Shared a_str_t88_Text As String
    Public Shared a_str_t88_Feldbez As String
    Public Shared a_str_t88_Tabbez As String
    Public Shared a_str_t88_Zeit As String

    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für Personendaten                             *
    REM *------------------------------------------------------------*
    Public Shared x_int_ID() As Integer
    Public Shared x_str_Name() As String
    Public Shared x_str_GName() As String
    Public Shared x_str_VName() As String
    Public Shared x_str_GDat() As String
    Public Shared x_str_SDat() As String
    Public Shared x_str_GOrt() As String
    Public Shared x_str_SOrt() As String
    Public Shared x_str_GSort() As String
    Public Shared x_str_SSort() As String

    Public Shared p_int_ID As Double
    Public Shared p_str_Name As String
    Public Shared p_str_GebName As String
    Public Shared p_str_NameZ As String
    Public Shared p_str_Vorname As String
    Public Shared p_str_Rufname As String
    Public Shared p_str_SpitzN As String
    Public Shared p_str_Geschl As String
    Public Shared p_str_Titel As String
    Public Shared p_int_Vater As Double
    Public Shared p_int_Mutter As Double
    Public Shared p_str_GDat_TT As String
    Public Shared p_str_GDat_MM As String
    Public Shared p_str_GDat_JJ As String
    Public Shared p_str_GDat As String
    Public Shared p_int_GArt As Integer
    Public Shared p_str_GOrt As String
    Public Shared p_str_GUrk As String
    Public Shared p_str_GUrk2 As String
    Public Shared p_str_SDat_TT As String
    Public Shared p_str_SDat_MM As String
    Public Shared p_str_SDat_JJ As String
    Public Shared p_int_SArt As Integer
    Public Shared p_str_SDat As String
    Public Shared p_str_SOrt As String
    Public Shared p_str_SUrk As String
    Public Shared p_str_SUrk2 As String
    Public Shared p_str_Memo As String
    Public Shared p_int_Vater_Save As Integer
    Public Shared p_int_Mutter_Save As Integer

    Public Shared p_str_Konf As String
    Public Shared p_str_TDat_TT As String
    Public Shared p_str_TDat_MM As String
    Public Shared p_str_TDat_JJ As String
    Public Shared p_int_TDat_Art As Integer
    Public Shared p_str_TOrt As String
    Public Shared p_str_TUrk As String
    Public Shared p_str_TPriester As String
    Public Shared p_str_TKirche As String
    Public Shared p_str_FDat_TT As String
    Public Shared p_str_FDat_MM As String
    Public Shared p_str_FDat_JJ As String
    Public Shared p_int_FDat_Art As Integer
    Public Shared p_str_FOrt As String
    Public Shared p_str_FKirche As String
    Public Shared p_str_FPriester As String
    Public Shared p_str_FUrk As String
    Public Shared p_str_TBemerk As String

    Public Shared p_str_BDat_JJ As String
    Public Shared p_str_BDat_MM As String
    Public Shared p_str_BDat_TT As String
    Public Shared p_int_BDat_Art As Integer
    Public Shared p_str_Grablage As String
    Public Shared p_str_BUrk1 As String
    Public Shared p_str_BUrk2 As String
    Public Shared p_str_TodUrsache As String
    Public Shared p_str_Friedhof As String
    Public Shared p_str_BPriester As String
    Public Shared p_str_BArt As String
    Public Shared p_str_BOrt As String
    Public Shared p_str_BBemerk As String

    Public Shared p_str_EDat1_TT As String
    Public Shared p_str_EDat1_MM As String
    Public Shared p_str_EDat1_JJ As String
    Public Shared p_int_EDat1_Art As Integer
    Public Shared p_str_EDat2_TT As String
    Public Shared p_str_EDat2_MM As String
    Public Shared p_str_Edat2_JJ As String
    Public Shared p_int_EDat2_Art As Integer
    Public Shared p_str_EDat3_TT As String
    Public Shared p_str_EDat3_MM As String
    Public Shared p_str_EDat3_JJ As String
    Public Shared p_int_EDat3_Art As Integer
    Public Shared p_str_EOrt1 As String
    Public Shared p_str_EOrt2 As String
    Public Shared p_str_EBeamter As String
    Public Shared p_str_EPriester As String
    Public Shared p_str_EUrk1 As String
    Public Shared p_str_EUrk2 As String
    Public Shared p_str_EUrk3 As String
    Public Shared p_str_EKirche As String
    Public Shared p_str_E_Bemerk As String

    Public Shared p_str_Komm_Name As String
    Public Shared p_str_Komm_GebName As String
    Public Shared p_str_Komm_Vorname As String
    Public Shared p_str_Komm_Rufname As String
    Public Shared p_str_Komm_NameZ As String
    Public Shared p_str_Komm_SpitzN As String
    Public Shared p_str_Komm_GDat As String
    Public Shared p_str_Komm_GOrt As String
    Public Shared p_str_Komm_Geb1 As String
    Public Shared p_str_Komm_Geb2 As String
    Public Shared p_str_Komm_SDat As String
    Public Shared p_str_Komm_SOrt As String
    Public Shared p_str_Komm_Sterb1 As String
    Public Shared p_str_Komm_Sterb2 As String
    Public Shared p_str_Komm_Titel As String

    Public Shared p_str_Komm_TDat As String
    Public Shared p_str_Komm_TOrt As String
    Public Shared p_str_Komm_TKirch As String
    Public Shared p_str_Komm_TKonf As String
    Public Shared p_str_Komm_TPriester As String
    Public Shared p_str_Komm_TUrk As String

    Public Shared p_str_Komm_FDat As String
    Public Shared p_str_Komm_FOrt As String
    Public Shared p_str_Komm_FKirche As String
    Public Shared p_str_Komm_FPriester As String
    Public Shared p_str_Komm_FUrk As String

    Public Shared p_str_Komm_BDat As String
    Public Shared p_str_Komm_BOrt As String
    Public Shared p_str_Komm_BArt As String
    Public Shared p_str_Komm_BPriester As String
    Public Shared p_str_Komm_Friedhof As String
    Public Shared p_str_Komm_Grablage As String
    Public Shared p_str_Komm_TodUrsache As String
    Public Shared p_str_Komm_BUrk1 As String
    Public Shared p_str_Komm_BUrk2 As String

    Public Shared p_int_Adr_Lfd As Integer
    Public Shared p_str_Adr_Land As String
    Public Shared p_str_Adr_Ort As String
    Public Shared p_str_Adr_ZIP As String
    Public Shared p_str_Adr_Strasse As String
    Public Shared p_str_Adr_Tel1 As String
    Public Shared p_str_Adr_Tel2 As String
    Public Shared p_str_Adr_Fax As String
    Public Shared p_str_Adr_Mail As String
    Public Shared p_str_Adr_www As String
    Public Shared p_str_Adr_DatV As String
    Public Shared p_str_Adr_DatV_TT As String
    Public Shared p_str_Adr_DatV_MM As String
    Public Shared p_str_Adr_DatV_JJ As String
    Public Shared p_str_Adr_DatB As String
    Public Shared p_str_Adr_DatB_TT As String
    Public Shared p_str_Adr_DatB_MM As String
    Public Shared p_str_Adr_DatB_JJ As String

    Public Shared p_int_Ber_Lfd As Integer
    Public Shared p_str_Beruf As String
    Public Shared p_str_Ber_DatV As String
    Public Shared p_str_Ber_DatV_TT As String
    Public Shared p_str_Ber_DatV_MM As String
    Public Shared p_str_Ber_DatV_JJ As String
    Public Shared p_str_Ber_DatB As String
    Public Shared p_str_Ber_DatB_TT As String
    Public Shared p_str_Ber_DatB_MM As String
    Public Shared p_str_Ber_DatB_JJ As String

    Public Shared p_str_Komm_EDat1 As String
    Public Shared p_str_Komm_EDat2 As String
    Public Shared p_str_Komm_EDat3 As String
    Public Shared p_str_Komm_EOrt1 As String
    Public Shared p_str_Komm_EOrt2 As String
    Public Shared p_str_Komm_ETZ1 As String
    Public Shared p_str_Komm_ETZ2 As String
    Public Shared p_str_Komm_EBeamt As String
    Public Shared p_str_Komm_EPriester As String
    Public Shared p_str_Komm_EKirche As String
    Public Shared p_str_Komm_EUrk1 As String
    Public Shared p_str_Komm_EUrk2 As String
    Public Shared p_str_Komm_EUrk3 As String

    Public Shared p_int_Ehe As Double
    Public Shared p_int_Ehe41 As Double
    Public Shared p_int_Ges As Double
    Public Shared p_int_Kind As Double
    Public Shared p_int_Pate As Double
    Public Shared p_int_Pate1 As Double
    Public Shared p_int_Zeuge As Double
    Public Shared p_int_Zeuge1 As Double
    Public Shared p_int_Zeuge2 As Double

    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für die Rolle Vater                           *
    REM *------------------------------------------------------------*
    Public Shared v_lng_ID As Double
    Public Shared v_str_Name As String
    Public Shared v_str_GebName As String
    Public Shared v_str_Vorname As String
    Public Shared v_str_GDat_TT As String
    Public Shared v_str_GDat_MM As String
    Public Shared v_str_GDat_JJ As String
    Public Shared v_str_GOrt As String
    Public Shared v_str_SDat_TT As String
    Public Shared v_str_SDat_MM As String
    Public Shared v_str_SDat_JJ As String
    Public Shared v_str_SOrt As String

    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für die Rolle Mutter                          *
    REM *------------------------------------------------------------*
    Public Shared m_lng_ID As Double
    Public Shared m_str_Name As String
    Public Shared m_str_GebName As String
    Public Shared m_str_Vorname As String
    Public Shared m_str_GDat_TT As String
    Public Shared m_str_GDat_MM As String
    Public Shared m_str_GDat_JJ As String
    Public Shared m_str_GOrt As String
    Public Shared m_str_SDat_TT As String
    Public Shared m_str_SDat_MM As String
    Public Shared m_str_SDat_JJ As String
    Public Shared m_str_SOrt As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Ehedaten                             *
    REM *------------------------------------------------------------*
    Public Shared te_lng_ID() As Double
    Public Shared te_str_Name() As String
    Public Shared te_str_GebName() As String
    Public Shared te_str_Vorname() As String
    Public Shared te_str_GDat_TT() As String
    Public Shared te_str_GDat_MM() As String
    Public Shared te_str_GDat_JJ() As String
    Public Shared te_str_GOrt() As String
    Public Shared te_str_SDat_TT() As String
    Public Shared te_str_SDat_MM() As String
    Public Shared te_str_SDat_JJ() As String
    Public Shared te_str_SOrt() As String
    Public Shared te_str_Geschl() As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Adressdaten                          *
    REM *------------------------------------------------------------*
    Public Shared ta_lng_ID() As Double
    Public Shared ta_int_LFD() As Integer
    Public Shared ta_dt_DatVon() As String
    Public Shared ta_dt_DatBis() As String
    Public Shared ta_str_PLZ() As String
    Public Shared ta_str_Ort() As String
    Public Shared ta_str_Land() As String
    Public Shared ta_str_Strasse() As String
    Public Shared ta_str_Tel1() As String
    Public Shared ta_str_Tel2() As String
    Public Shared ta_str_Fax() As String
    Public Shared ta_str_Mail() As String
    Public Shared ta_str_www() As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Berufsdaten                          *
    REM *------------------------------------------------------------*
    Public Shared tb_lng_ID() As Double
    Public Shared tb_int_LFD() As Integer
    Public Shared tb_dt_DatVon() As String
    Public Shared tb_dt_DatBis() As String
    Public Shared tb_str_Beruf() As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Geschwisterolle                      *
    REM *------------------------------------------------------------*
    Public Shared tg_lng_ID() As Double
    Public Shared tg_str_Name() As String
    Public Shared tg_str_GebName() As String
    Public Shared tg_str_Vorname() As String
    Public Shared tg_str_GDat_TT() As String
    Public Shared tg_str_GDat_MM() As String
    Public Shared tg_str_GDat_JJ() As String
    Public Shared tg_str_GOrt() As String
    Public Shared tg_str_SDat_TT() As String
    Public Shared tg_str_SDat_MM() As String
    Public Shared tg_str_SDat_JJ() As String
    Public Shared tg_str_SOrt() As String
    Public Shared tg_str_Geschl() As String
    Public Shared tg_lng_IDV() As Double
    Public Shared tg_lng_IDM() As Double

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Kinderrolle                          *
    REM *------------------------------------------------------------*
    Public Shared tk_lng_ID() As Double
    Public Shared tk_str_Name() As String
    Public Shared tk_str_GebName() As String
    Public Shared tk_str_Vorname() As String
    Public Shared tk_str_GDat_TT() As String
    Public Shared tk_str_GDat_MM() As String
    Public Shared tk_str_GDat_JJ() As String
    Public Shared tk_str_GOrt() As String
    Public Shared tk_str_SDat_TT() As String
    Public Shared tk_str_SDat_MM() As String
    Public Shared tk_str_SDat_JJ() As String
    Public Shared tk_str_SOrt() As String
    Public Shared tk_str_Geschl() As String
    Public Shared tk_lng_IDV() As Double
    Public Shared tk_lng_IDM() As Double

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Patenrolle                           *
    REM *------------------------------------------------------------*
    Public Shared tp_lng_ID() As Double
    Public Shared tp_str_Name() As String
    Public Shared tp_str_GebName() As String
    Public Shared tp_str_Vorname() As String
    Public Shared tp_str_GDat_TT() As String
    Public Shared tp_str_GDat_MM() As String
    Public Shared tp_str_GDat_JJ() As String
    Public Shared tp_str_GOrt() As String
    Public Shared tp_str_SDat_TT() As String
    Public Shared tp_str_SDat_MM() As String
    Public Shared tp_str_SDat_JJ() As String
    Public Shared tp_str_SOrt() As String
    Public Shared tp_str_Geschl() As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Patenrolle                           *
    REM *------------------------------------------------------------*
    Public Shared tp1_lng_ID() As Double
    Public Shared tp1_str_Name() As String
    Public Shared tp1_str_GebName() As String
    Public Shared tp1_str_Vorname() As String
    Public Shared tp1_str_GDat_TT() As String
    Public Shared tp1_str_GDat_MM() As String
    Public Shared tp1_str_GDat_JJ() As String
    Public Shared tp1_str_GOrt() As String
    Public Shared tp1_str_SDat_TT() As String
    Public Shared tp1_str_SDat_MM() As String
    Public Shared tp1_str_SDat_JJ() As String
    Public Shared tp1_str_SOrt() As String
    Public Shared tp1_str_Geschl() As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Trauzeugenrolle                      *
    REM *------------------------------------------------------------*
    Public Shared tz_lng_ID() As Double
    Public Shared tz_str_Name() As String
    Public Shared tz_str_GebName() As String
    Public Shared tz_str_Vorname() As String
    Public Shared tz_str_GDat_TT() As String
    Public Shared tz_str_GDat_MM() As String
    Public Shared tz_str_GDat_JJ() As String
    Public Shared tz_str_GOrt() As String
    Public Shared tz_str_SDat_TT() As String
    Public Shared tz_str_SDat_MM() As String
    Public Shared tz_str_SDat_JJ() As String
    Public Shared tz_str_SOrt() As String
    Public Shared tz_str_Geschl() As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Trauzeugenrolle                      *
    REM *------------------------------------------------------------*
    Public Shared tz1_lng_ID() As Double
    Public Shared tz1_str_Name() As String
    Public Shared tz1_str_GebName() As String
    Public Shared tz1_str_Vorname() As String
    Public Shared tz1_str_GDat_TT() As String
    Public Shared tz1_str_GDat_MM() As String
    Public Shared tz1_str_GDat_JJ() As String
    Public Shared tz1_str_GOrt() As String
    Public Shared tz1_str_SDat_TT() As String
    Public Shared tz1_str_SDat_MM() As String
    Public Shared tz1_str_SDat_JJ() As String
    Public Shared tz1_str_SOrt() As String
    Public Shared tz1_str_Geschl() As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Trauzeugenrolle                      *
    REM *------------------------------------------------------------*
    Public Shared tz2_lng_ID() As Double
    Public Shared tz2_str_Name() As String
    Public Shared tz2_str_GebName() As String
    Public Shared tz2_str_Vorname() As String
    Public Shared tz2_str_GDat_TT() As String
    Public Shared tz2_str_GDat_MM() As String
    Public Shared tz2_str_GDat_JJ() As String
    Public Shared tz2_str_GOrt() As String
    Public Shared tz2_str_SDat_TT() As String
    Public Shared tz2_str_SDat_MM() As String
    Public Shared tz2_str_SDat_JJ() As String
    Public Shared tz2_str_SOrt() As String
    Public Shared tz2_str_Geschl() As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für die Rollendaten                          *
    REM *------------------------------------------------------------*
    Public Shared r_lng_ID As Double
    Public Shared r_str_Name As String
    Public Shared r_str_GebName As String
    Public Shared r_str_Vorname As String
    Public Shared r_str_GDat_TT As String
    Public Shared r_str_GDat_MM As String
    Public Shared r_str_GDat_JJ As String
    Public Shared r_str_GOrt As String
    Public Shared r_str_SDat_TT As String
    Public Shared r_str_SDat_MM As String
    Public Shared r_str_SDat_JJ As String
    Public Shared r_str_SOrt As String
    Public Shared r_str_Geschl As String
    Public Shared r_lng_IDV As Double
    Public Shared r_lng_IDM As Double

    REM *------------------------------------------------------------*
    REM *  Datenspeicher für Plausi-Daten                            *
    REM *------------------------------------------------------------*
    Public Shared s_str_Geschl As String
    Public Shared s_int_Vater As Double
    Public Shared s_int_Mutter As Double
    Public Shared s_str_GDat_TT As String
    Public Shared s_str_GDat_MM As String
    Public Shared s_str_GDat_JJ As String
    Public Shared s_str_SDat_TT As String
    Public Shared s_str_SDat_MM As String
    Public Shared s_str_SDat_JJ As String
    Public Shared s_str_GDat As String
    Public Shared s_str_SDat As String


    REM *------------------------------------------------------------*
    REM *  HIlfsfelder für Konsistenzprüfung                         *
    REM *------------------------------------------------------------*
    Public Shared lng_Kon_GDat As Double
    Public Shared lng_Kon_TDat As Double
    Public Shared lng_Kon_SDat As Double
    Public Shared lng_Kon_EDat As Double
    Public Shared lng_Kon_V_GDat As Double
    Public Shared lng_Kon_V_SDat As Double
    Public Shared lng_Kon_M_GDat As Double
    Public Shared lng_Kon_M_SDat As Double

    Public Shared lng_Kon_D_Geb As Double
    Public Shared lng_Kon_D_Ehe As Double
    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für Kommentare                               *
    REM *------------------------------------------------------------*
    Public Shared str_Tab_Komm(50) As String
    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für Orte                               *
    REM *------------------------------------------------------------*
    Public Shared str_Tab_Orte() As String
    Public Shared int_Tab_Orte() As Integer
    Public Shared int_Anz_Ort As Integer
    Public Shared int_Anz_Ort0() As Integer
    Public Shared int_Anz_Ort1() As Integer
    Public Shared int_Anz_Ort2() As Integer
    Public Shared int_Anz_Ort3() As Integer
    Public Shared int_Anz_Ort4() As Integer
    Public Shared int_Anz_Ort5() As Integer
    Public Shared int_Anz_Ort6() As Integer
    Public Shared int_Anz_Ort7() As Integer

    REM *------------------------------------------------------------*
    REM *  Tabelle für Feldbezeichnungen                           *
    REM *------------------------------------------------------------*
    Public Shared str_FeldBez(8, 20) As String

    REM *------------------------------------------------------------*
    REM *  Hilfstabelle für Historiendaten                           *
    REM *------------------------------------------------------------*
    Public Shared int_His_Nr(50) As Integer
    Public Shared str_His(50) As String
    Public Shared int_His_Tab As Integer
    Public Shared int_His_Count As Integer
    Public Shared str_Feld_Text(7, 25) As String
    Public Shared str_Tab_Text(7) As String
    REM *------------------------------------------------------------*
    REM *  Hilfsfelder für Gridausdruck                              *
    REM *------------------------------------------------------------*
    Public Shared int_Druck_Spalte(15) As Integer
    Public Shared int_Druck_Spaltx(15) As Integer
    Public Shared int_Druck_TabID(15) As Integer
    Public Shared str_Druck_Spalte(15) As String
    Public Shared str_Druck_SpaltN(15) As String
    Public Shared int_SPZ As Integer = 0

    Public Shared int_GBreite As Integer = 0

    Public Shared ZellBox As New Rectangle
    Public Shared ZellBoxZ As New Rectangle
    Public Shared sf As New StringFormat

    Public Shared LRand As Decimal
    Public Shared RRand As Decimal
    Public Shared ROben As Decimal
    Public Shared RUnten As Decimal

    Public Shared PageWidth As Integer
    Public Shared PageHeight As Decimal

    Public Shared dgv_MaxZeilenIndex As Integer
    Public Shared dgv_MaxSpaltenIndex As Integer

    Public Shared ZellInhalt As String
    Public Shared PosX As Integer
    Public Shared PosY As Integer
    Public Shared PosX1 As Integer
    Public Shared SpaltenBreiten As New List(Of Integer)      ' Auflistung mit der Breite der einzelnen Spalten

    Public Shared TextHöhe As Integer
    Public Shared HeaderHöhe As Integer
    Public Shared DruckSpalte As Integer
    Public Shared DruckZeile As Integer
    Public Shared DGVSpaltenIndex As Integer
    Public Shared DGVZeilenIndex As Integer
    Public Shared DGVDruckbreite As Integer
    Public Shared ZellPadding As Integer = 5
    Public Shared Querformat As Boolean = True

    Public Shared HeaderColor As System.Drawing.Color = Color.LightGray
    Public Shared RowColor As System.Drawing.Color = Color.White
    Public Shared RowColorAlternate As System.Drawing.Color = Color.LightYellow
    Public Shared HZentrieren As Boolean = False
    Public Shared DruckeGitternetzlinien As Boolean = True
    Public Shared SpaltenAutoSize As Boolean = False

    REM Variable für Datenimport von GM3 - GenMaster
    REM *  Personendaten (fam)
    Public Shared GM1_Nr As String
    Public Shared GM1_Name As String
    Public Shared GM1_Vorname As String
    Public Shared GM1_Titel As String
    Public Shared GM1_Vater As String
    Public Shared GM1_Mutter As String
    Public Shared GM1_Text As String
    Public Shared GM1_Geschlecht As String
    Public Shared GM1_GebTag As String
    Public Shared GM1_GebMonat As String
    Public Shared GM1_GebJahr As String
    Public Shared GM1_StTag As String
    Public Shared GM1_StMonat As String
    Public Shared GM1_StJahr As String
    Public Shared GM1_GebOrt As String
    Public Shared GM1_StOrt As String
    Public Shared GM1_Name2 As String
    Public Shared GM1_GebName As String
    Public Shared GM1_GNummer As String
    Public Shared GM1_SNummer As String
    Public Shared GM1_Konfess As String
    Public Shared GM1_TaufDat As String
    Public Shared GM1_TaufIn As String
    Public Shared GM1_TaufKirche As String
    Public Shared GM1_TaufReg As String
    Public Shared GM1_TaufRegIn As String
    Public Shared GM1_KonfDat As String
    Public Shared GM1_Konfin As String
    Public Shared GM1_KonReg As String
    Public Shared GM1_KonRegin As String
    Public Shared GM1_GebRegIn As String
    Public Shared GM1_GesRegIn As String
    Public Shared GM1_BeerdDat As String
    Public Shared GM1_BeerdIn As String
    Public Shared GM1_GrabNr As String
    Public Shared GM1_GrabIn As String
    Public Shared GM1_Todesursache As String
    Public Shared GM1_AnlDat As String
    Public Shared GM1_AenDat As String

    REM *  Bilddaten (fabild)
    Public Shared GM2_ID As String
    Public Shared GM2_Pfad As String
    Public Shared GM2_Text As String

    REM *  Bilddaten Ehe (fabilde)
    Public Shared GM3_ID1 As String
    Public Shared GM3_ID2 As String
    Public Shared GM3_Pfad As String
    Public Shared GM3_Text As String

    REM *  Adressdaten (famadr)
    Public Shared GM4_ID As String
    Public Shared GM4_Land As String
    Public Shared GM4_PLZ As String
    Public Shared GM4_Ort As String
    Public Shared GM4_Strasse As String
    Public Shared GM4_Tel1 As String
    Public Shared GM4_Tel2 As String
    Public Shared GM4_von As String
    Public Shared GM4_bis As String
    Public Shared GM4_Fax As String
    Public Shared GM4_Mail As String

    REM *  Berufe + Paten + Zeugen (famdat) 
    Public Shared GM5_Art As String
    Public Shared GM5_ID As String
    Public Shared GM5_ID2 As String
    Public Shared GM5_Text As String
    Public Shared GM5_TabIndex As Integer = 0

    REM * Ehedaten (famehe)
    Public Shared GM6_ID1 As String
    Public Shared GM6_ID2 As String
    Public Shared GM6_Text As String
    Public Shared GM6_KDat_TT As String
    Public Shared GM6_KDat_MM As String
    Public Shared GM6_KDat_JJ As String
    Public Shared GM6_K_Ort As String
    Public Shared GM6_K_Priester As String
    Public Shared GM6_SDat_TT As String
    Public Shared GM6_SDat_MM As String
    Public Shared GM6_SDat_JJ As String
    Public Shared GM6_S_Ort As String
    Public Shared GM6_S_Beamter As String
    Public Shared GM6_KEnde_TT As String
    Public Shared GM6_KEnde_MM As String
    Public Shared GM6_KEnde_JJ As String
    Public Shared GM6_SEnde_TT As String
    Public Shared GM6_SEnde_MM As String
    Public Shared GM6_SEnde_JJ As String
    Public Shared GM6_K_Urk As String
    Public Shared GM6_S_Urk As String
    Public Shared GM6_KEnde_Urk As String
    Public Shared GM6_SEnde_Urk As String
    Public Shared GM6_Kirche As String
    Public Shared GM6_VDat As String
    Public Shared GM6_VOrt As String

    Public Shared GM_str_NR() As String
    Public Shared int_GM1 As Integer
    Public Shared int_GM2 As Integer
    Public Shared int_GM3 As Integer
    Public Shared GM_str_1 As String
    Public Shared GM_Nr As String
    Public Shared str_LogFile As String

    REM * Arbeitsfelder für GedCom
    Public Shared Ged_Ort As String
    Public Shared int_Ged_Tab As Integer = -1
    Public Shared int_Gedcom As Integer
    Public Shared Ged_ID() As Long
    Public Shared Ged_Name() As String
    Public Shared Ged_Geschlecht() As String
    Public Shared Ged_Beruf() As String
    Public Shared Ged_Adresse() As String
    Public Shared Ged_GebDatum() As String
    Public Shared Ged_Religion() As String
    Public Shared Ged_BeerdDatum() As String
    Public Shared Ged_TaufDatum() As String
    Public Shared Ged_StDatum() As String
    Public Shared Ged_StOrt() As String
    Public Shared Ged_GebOrt() As String
    Public Shared Ged_TaufOrt() As String
    Public Shared Ged_BeerdOrt() As String
    Public Shared int_GdMerk_Birt As Integer = 0
    Public Shared int_GdMerk_Chr As Integer = 0
    Public Shared int_GdMerk_Deat As Integer = 0
    Public Shared int_GdMerk_Reli As Integer = 0
    Public Shared int_GdMerk_Buri As Integer = 0

    REM * Speicher für Generationenlisten
    Public Shared Gen_01(,) As Integer
    Public Shared Gen_02(,) As Integer
    Public Shared Gen_03(,) As Integer
    Public Shared Gen_04(,) As Integer
    Public Shared Gen_05(,) As Integer
    Public Shared Gen_06(,) As Integer
    Public Shared Gen_07(,) As Integer
    Public Shared Gen_08(,) As Integer
    Public Shared Gen_09(,) As Integer
    Public Shared Gen_10(,) As Integer
    Public Shared Gen_11(,) As Integer
    Public Shared Gen_12(,) As Integer
    Public Shared Gen_13(,) As Integer
    Public Shared Gen_14(,) As Integer
    Public Shared Gen_15(,) As Integer
    Public Shared GenZ01 As Integer
    Public Shared GenZ02 As Integer
    Public Shared GenZ03 As Integer
    Public Shared GenZ04 As Integer
    Public Shared GenZ05 As Integer
    Public Shared GenZ06 As Integer
    Public Shared GenZ07 As Integer
    Public Shared GenZ08 As Integer
    Public Shared GenZ09 As Integer
    Public Shared GenZ10 As Integer
    Public Shared GenZ11 As Integer
    Public Shared GenZ12 As Integer
    Public Shared GenZ13 As Integer
    Public Shared GenZ14 As Integer
    Public Shared GenZ15 As Integer
    Public Shared int_ST1 As Integer
    Public Shared int_ST2 As Integer
    Public Shared int_ST3 As Integer
    Public Shared int_ST4 As Integer
    Public Shared int_ST5 As Integer
    Public Shared int_ST6 As Integer
    Public Shared int_ST7 As Integer
    Public Shared int_ST8 As Integer
    Public Shared int_ST9 As Integer
    Public Shared int_ST10 As Integer
    Public Shared int_ST11 As Integer
    Public Shared int_ST12 As Integer
    Public Shared int_ST13 As Integer
    Public Shared int_ST14 As Integer
    Public Shared int_ST15 As Integer

    Public Shared Gen_Str() As String
    Public Shared Gen_Str1() As String
    Public Shared int_GenZ As Integer
    Public Shared Gen_STZ As Integer
    Public Shared Gen_SP As Integer
    Public Shared Gen_ID() As Long
    Public Shared Gen_Kind As Integer
    Public Shared Gen_Kekule() As Integer
    Public Shared Gen_Vater() As Long
    Public Shared Gen_Mutter() As Long
    Public Shared Gen_Stufe() As Integer
    Public Shared Gen_StufID() As Integer
    Public Shared Gen_Tab_Ins As Integer
    Public Shared Gen_Tab_Read As Integer
    Public Shared Gen_Kek As Integer
    Public Shared Gen_Stuf As Integer
    Public Shared Gen_XStuf As Integer
    Public Shared Gen_XStufe() As Integer
    Public Shared Gen_Nach_Max As Integer
    Public Shared Gen_Grad As String
    Public Shared Gen_NF(,) As Long
    Public Shared Gen_AltID() As Long
    Public Shared Gen_Alt1() As String
    Public Shared Gen_x1() As Integer
    Public Shared Gen_x2() As Integer
    Public Shared Gen_Lg As Integer = 5
    Public Shared Gen_NF_High As Integer
    Public Shared Gen_Start As String
    Public Shared Gen_Nr As Integer
    Public Shared dbl_Anz_Seit As Double
    Public Shared int_Anz_Seit As Integer
    Public Shared int_Anz_Sub As Integer
    Public Shared int_NF_Seit_Max As Integer = 31
    Public Shared Gen_Zeil1() As String
    Public Shared Gen_Zeil2() As String
    Public Shared Gen_Zeil3() As String
    Public Shared Gen_Zeil4() As String
    Public Shared Gen_Zeil5() As String
    Public Shared Gen_Zeil6() As String
    Public Shared Gen_Zeil7() As String
    Public Shared Gen_Zeil8() As String
    Public Shared Gen_Zeilen As Integer
    Public Shared Gen_Head01 As String
    Public Shared Gen_Head02 As String
    Public Shared Gen_Head03 As String
    Public Shared Gen_Head04 As String
    Public Shared Gen_Head05 As String
    Public Shared Gen_Head06 As String
    Public Shared Gen_Head07 As String
    Public Shared Gen_Head08 As String

    Public Shared Ged_Ehe() As Double
    Public Shared Ged_P1() As Double
    Public Shared Ged_P2() As Double

    Public Shared str_Sort_tx(9) As String
    Public Shared str_Sort_Feld(9) As String
    Public Shared int_Sort_ID(9) As Integer
    Public Shared int_Sort_Wert(9) As Integer
    Public Shared str_Sort_Folge As String
    Public Shared int_Sort_Merk As Integer

    Public Shared Gen_Merk_Zeile As Integer
    Public Shared iT As Integer
    Public Shared tx_Kopf01 As String
    Public Shared tx_Fuss01 As String
    Public Shared tx_Zeil1(80) As String
    Public Shared tx_Zeil2(80) As String

    Public Structure Sortfelder
        Public Feld1 As Integer
        Public Feld2 As Integer
        Public Feld3 As Integer
    End Structure
    Public Indexlist As New List(Of Sortfelder)

    'Public Shared WithEvents PrintDoc As New System.Drawing.Printing.PrintDocument

End Class
