﻿Imports NM_Ahnen.Cls_00_Def
Imports NM_Ahnen.Cls_02_DB

Public Class Cls_30_Search

    REM **************************************************************
    REM *  Löschen der Textfelder für Searchmaske                    *
    REM **************************************************************
    Public Shared Sub Clear_91()
        With NM_Ahnen_Search
            .tx_91_Name_von.Text = ""
            .tx_91_Name_bis.Text = ""
            .tx_91_Vorname_von.Text = ""
            .tx_91_Vorname_bis.Text = ""
            .tx_91_GOrt_von.Text = ""
            .tx_91_GOrt_bis.Text = ""
            .tx_91_GDat_TT_von.Text = ""
            .tx_91_GDat_TT_bis.Text = ""
            .tx_91_GDat_MM_von.Text = ""
            .tx_91_GDat_MM_bis.Text = ""
            .tx_91_GDat_JJ_von.Text = ""
            .tx_91_GDat_JJ_bis.Text = ""
            .tx_91_SDat_TT_von.Text = ""
            .tx_91_SDat_TT_bis.Text = ""
            .tx_91_SDat_MM_von.Text = ""
            .tx_91_SDat_MM_bis.Text = ""
            .tx_91_SDat_JJ_von.Text = ""
            .tx_91_SDat_JJ_bis.Text = ""
            .tx_91_SOrt_von.Text = ""
            .tx_91_SOrt_bis.Text = ""
            .tx_91_Geschlecht.Text = ""
            .tx_91_GDat_P1_von.Text = "."
            .tx_91_GDat_P2_von.Text = "."
            .tx_91_GDat_P1_bis.Text = "."
            .tx_91_GDat_P2_bis.Text = "."
            .tx_91_SDat_P1_von.Text = "."
            .tx_91_SDat_P2_von.Text = "."
            .tx_91_SDat_P1_bis.Text = "."
            .tx_91_SDat_P2_bis.Text = "."
            Call TabPos_91()
        End With
    End Sub

    REM **************************************************************
    REM *  Bestimmen der Tab-Positionen für Searchfelder             *
    REM **************************************************************
    Public Shared Sub TabPos_91()
        With NM_Ahnen_Search
            .tx_91_Name_von.TabIndex = 0
            .tx_91_Name_bis.TabIndex = 1
            .tx_91_Vorname_von.TabIndex = 2
            .tx_91_Vorname_bis.TabIndex = 3
            .tx_91_GDat_TT_von.TabIndex = 4
            .tx_91_GDat_MM_von.TabIndex = 5
            .tx_91_GDat_JJ_von.TabIndex = 6
            .tx_91_GDat_TT_bis.TabIndex = 7
            .tx_91_GDat_MM_bis.TabIndex = 8
            .tx_91_GDat_JJ_bis.TabIndex = 9
            .tx_91_GOrt_von.TabIndex = 10
            .tx_91_GOrt_bis.TabIndex = 11
            .tx_91_SDat_TT_von.TabIndex = 12
            .tx_91_SDat_MM_von.TabIndex = 13
            .tx_91_SDat_JJ_von.TabIndex = 14
            .tx_91_SDat_TT_bis.TabIndex = 15
            .tx_91_SDat_MM_bis.TabIndex = 16
            .tx_91_SDat_JJ_bis.TabIndex = 17
            .tx_91_SOrt_von.TabIndex = 18
            .tx_91_SOrt_bis.TabIndex = 19
            .tx_91_Geschlecht.TabIndex = 20
            .tx_91_GDat_von.TabStop = False
            .tx_91_GDat_bis.TabStop = False
            .tx_91_SDat_von.TabStop = False
            .tx_91_SDat_bis.TabStop = False
            .tx_91_GDat_P1_von.TabStop = False
            .tx_91_GDat_P2_von.TabStop = False
            .tx_91_GDat_P1_bis.TabStop = False
            .tx_91_GDat_P2_bis.TabStop = False
            .tx_91_SDat_P1_von.TabStop = False
            .tx_91_SDat_P2_von.TabStop = False
            .tx_91_SDat_P1_bis.TabStop = False
            .tx_91_SDat_P2_bis.TabStop = False
            .tx_91_GDat_von.ReadOnly = True
            .tx_91_GDat_bis.ReadOnly = True
            .tx_91_SDat_von.ReadOnly = True
            .tx_91_SDat_bis.ReadOnly = True
            .tx_91_GDat_P1_von.ReadOnly = True
            .tx_91_GDat_P2_von.ReadOnly = True
            .tx_91_GDat_P1_bis.ReadOnly = True
            .tx_91_GDat_P2_bis.ReadOnly = True
            .tx_91_SDat_P1_von.ReadOnly = True
            .tx_91_SDat_P2_von.ReadOnly = True
            .tx_91_SDat_P1_bis.ReadOnly = True
            .tx_91_SDat_P2_bis.ReadOnly = True
        End With
    End Sub

    REM **************************************************************
    REM *  Prüfen auf Eingabe und Zusammenbau                        *
    REM **************************************************************
    Public Shared Sub Verarb_Detail()
        Dim AnzInp As Integer = 0
        With NM_Ahnen_Search
            If .tx_91_Name_von.Text > "" Then AnzInp += 1
            If .tx_91_Name_bis.Text > "" Then AnzInp += 1
            If .tx_91_Vorname_von.Text > "" Then AnzInp += 1
            If .tx_91_Vorname_bis.Text > "" Then AnzInp += 1
            If .tx_91_GDat_TT_von.Text > "" Then AnzInp += 1
            If .tx_91_GDat_TT_bis.Text > "" Then AnzInp += 1
            If .tx_91_GDat_MM_von.Text > "" Then AnzInp += 1
            If .tx_91_GDat_MM_bis.Text > "" Then AnzInp += 1
            If .tx_91_GDat_JJ_von.Text > "" Then AnzInp += 1
            If .tx_91_GDat_JJ_bis.Text > "" Then AnzInp += 1
            If .tx_91_GOrt_von.Text > "" Then AnzInp += 1
            If .tx_91_GOrt_bis.Text > "" Then AnzInp += 1
            If .tx_91_SDat_TT_von.Text > "" Then AnzInp += 1
            If .tx_91_SDat_TT_bis.Text > "" Then AnzInp += 1
            If .tx_91_SDat_MM_von.Text > "" Then AnzInp += 1
            If .tx_91_SDat_MM_bis.Text > "" Then AnzInp += 1
            If .tx_91_SDat_JJ_von.Text > "" Then AnzInp += 1
            If .tx_91_SDat_JJ_bis.Text > "" Then AnzInp += 1
            If .tx_91_SOrt_von.Text > "" Then AnzInp += 1
            If .tx_91_SOrt_bis.Text > "" Then AnzInp += 1
            If .tx_91_Geschlecht.Text > "" Then AnzInp += 1
        End With
        REM *------------------------------------------------------------*
        REM *  Falls Zähler = 0, so ist kein Text erfasst, Hinweis       *
        REM *------------------------------------------------------------*
        If AnzInp = 0 Then
            MsgBox("Keine Eingaben erfolgt!", MsgBoxStyle.Information)
            Exit Sub
        End If
        int_Merk_Plausi = 0
        str_Where = " where "
        Call Plausi_Search()
        If int_Merk_Plausi = 1 Then Exit Sub
        Call Wherestring()
        Call DB_Sel_All()
    End Sub

    REM **************************************************************
    REM *  Prüfen der Eingaben in Searchmaske auf Plausibilität      *
    REM **************************************************************
    Public Shared Sub Plausi_Search()

        Dim str_Pl1 As String
        Dim str_Pl2 As String
        With NM_Ahnen_Search
            Plausi_Dat(.tx_91_GDat_TT_von.Text, 1)
            If int_Merk_Plausi = 1 Then
                MsgBox("Tag Geburtsdatum von - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Tag Geburtsdatum von - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_GDat_TT_bis.Text, 1)
            If int_Merk_Plausi = 1 Then
                MsgBox("Tag Geburtsdatum bis - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Tag Geburtsdatum bis - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_GDat_MM_von.Text, 2)
            If int_Merk_Plausi = 1 Then
                MsgBox("Monat Geburtsdatum von - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Monat Geburtsdatum von - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_GDat_MM_bis.Text, 2)
            If int_Merk_Plausi = 1 Then
                MsgBox("Monat Geburtsdatum bis - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Monat Geburtsdatum bis - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_GDat_JJ_von.Text, 3)
            If int_Merk_Plausi = 1 Then
                MsgBox("Jahr Geburtsdatum von - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Jahr Geburtsdatum von - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_GDat_JJ_bis.Text, 3)
            If int_Merk_Plausi = 1 Then
                MsgBox("Jahr Geburtsdatum bis - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Jahr Geburtsdatum bis - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            str_Pl1 = .tx_91_GDat_JJ_bis.Text + .tx_91_GDat_MM_bis.Text + .tx_91_GDat_TT_bis.Text
            str_Pl2 = .tx_91_GDat_JJ_von.Text + .tx_91_GDat_MM_von.Text + .tx_91_GDat_TT_von.Text
            If str_Pl1 > "" Then
                If str_Pl2 > str_Pl1 Then
                    MsgBox("Geburtsdatum-bis  ist kleiner als   Geburtsdatum-von", MsgBoxStyle.OkOnly)
                    Exit Sub
                End If
            End If
            Plausi_Dat(.tx_91_SDat_TT_von.Text, 1)
            If int_Merk_Plausi = 1 Then
                MsgBox("Tag Sterbedatum von - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Tag Sterbedatum von - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_SDat_TT_bis.Text, 1)
            If int_Merk_Plausi = 1 Then
                MsgBox("Tag Sterbedatum bis - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Tag Sterbedatum bis - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_SDat_MM_von.Text, 2)
            If int_Merk_Plausi = 1 Then
                MsgBox("Monat Sterbedatum von - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Monat Sterbedatum von - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_SDat_MM_bis.Text, 2)
            If int_Merk_Plausi = 1 Then
                MsgBox("Monat Sterbedatum bis - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Monat Sterbedatum bis - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_SDat_JJ_von.Text, 3)
            If int_Merk_Plausi = 1 Then
                MsgBox("Jahr Sterbedatum von - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Jahr Sterbedatum von - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            Plausi_Dat(.tx_91_SDat_JJ_bis.Text, 3)
            If int_Merk_Plausi = 1 Then
                MsgBox("Jahr Sterbedatum bis - falsche Zahl", MsgBoxStyle.OkOnly)
                Exit Sub
            ElseIf int_Merk_Plausi = 2 Then
                MsgBox("Jahr Sterbedatum bis - numerischer Wert fehlt", MsgBoxStyle.OkOnly)
                Exit Sub
            End If
            str_Pl1 = .tx_91_SDat_JJ_bis.Text + .tx_91_SDat_MM_bis.Text + .tx_91_SDat_TT_bis.Text
            str_Pl2 = .tx_91_SDat_JJ_von.Text + .tx_91_SDat_MM_von.Text + .tx_91_SDat_TT_von.Text
            If str_Pl1 > "" Then
                If str_Pl2 > str_Pl1 Then
                    MsgBox("Sterbedatum-bis  ist kleiner als   Sterbedatum-von", MsgBoxStyle.OkOnly)
                    Exit Sub
                End If
            End If
            If .tx_91_Name_bis.Text > "" Then
                If .tx_91_Name_bis.Text < .tx_91_Name_von.Text Then
                    MsgBox("Name-bis  ist kleiner als   Name-von", MsgBoxStyle.OkOnly)
                    Exit Sub
                End If
            End If
            If .tx_91_Vorname_bis.Text > "" Then
                If .tx_91_Vorname_bis.Text < .tx_91_Vorname_von.Text Then
                    MsgBox("Vorname-bis  ist kleiner als   Vorname-von", MsgBoxStyle.OkOnly)
                    Exit Sub
                End If
            End If
            If .tx_91_GOrt_bis.Text > "" Then
                If .tx_91_GOrt_bis.Text < .tx_91_GOrt_von.Text Then
                    MsgBox("Geburtsort-bis  ist kleiner als   Geburtsort-von", MsgBoxStyle.OkOnly)
                    Exit Sub
                End If
            End If
            If .tx_91_SOrt_bis.Text > "" Then
                If .tx_91_SOrt_bis.Text < .tx_91_SOrt_von.Text Then
                    MsgBox("Sterbeort-bis  ist kleiner als   Sterbeort-von", MsgBoxStyle.OkOnly)
                    Exit Sub
                End If
            End If
        End With
    End Sub


    REM ******************************************************************
    REM *  Prüfung des Datums auf Plausibilität                          *
    REM *  prs = erfasstes Feld aus Maske                                *
    REM *  prt = Typ (1 = Tag, 2 = Monat, 3 = Jahr)                      *
    REM ******************************************************************
    Public Shared Function Plausi_Dat(ByVal prs As String, ByVal prt As Integer)

        Dim Ziff As Integer
        int_Merk_Plausi = 0
        REM *------------------------------------------------------------*
        REM *  Prüfen der Übergabestruktur, nur wenn Inhalt vorhanden    *
        REM *  wenn nicht numerisch, Fehler 2                            *
        REM *------------------------------------------------------------*
        If prs <> "" Then
            If IsNumeric(prs) Then
                Ziff = Val(prs)
                REM *----------------------------------------------------*
                REM *  Tage-Prüfung                                      *
                REM *----------------------------------------------------*
                If prt = 1 Then
                    If Ziff < 1 Or Ziff > 31 Then
                        int_Merk_Plausi = 1
                        Return int_Merk_Plausi
                    End If
                End If
                REM *----------------------------------------------------*
                REM *  Monats-Prüfung                                    *
                REM *----------------------------------------------------*
                If prt = 2 Then
                    If Ziff < 1 Or Ziff > 12 Then
                        int_Merk_Plausi = 1
                        Return int_Merk_Plausi
                    End If
                End If
                REM *----------------------------------------------------*
                REM *  Jahres-Prüfung                                    *
                REM *----------------------------------------------------*
                If prt = 3 Then
                    If Ziff < 1000 Or Ziff > 2100 Then
                        int_Merk_Plausi = 1
                        Return int_Merk_Plausi
                    End If
                End If
            Else
                int_Merk_Plausi = 2
                Return int_Merk_Plausi
            End If
        End If
        Return int_Merk_Plausi
    End Function

    REM **************************************************************
    REM *  Zusammenbau des Wherestrings                              *
    REM **************************************************************
    Public Shared Sub Wherestring()

        Dim AnzInp As Integer = 0
        str_Where2 = ""
        With NM_Ahnen_Search
            If .tx_91_Name_von.Text <> "" Then
                If .tx_91_Name_bis.Text <> "" Then
                    str_Where += "(t01_Name >= '" + .tx_91_Name_von.Text + "' and t01_Name <= '" + .tx_91_Name_bis.Text + "'"
                    str_Where += " or t01_GebName >= '" + .tx_91_Name_von.Text + "' and t01_GebName <= '" + .tx_91_Name_bis.Text + "'"
                    str_Where += " or t01_NameZ >= '" + .tx_91_Name_von.Text + "' and t01_NameZ <= '" + .tx_91_Name_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_Name = '" + .tx_91_Name_von.Text + "'"
                    str_Where += " or t01_GebName = '" + .tx_91_Name_von.Text + "'"
                    str_Where += " or t01_NameZ = '" + .tx_91_Name_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_Vorname_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_Vorname_bis.Text <> "" Then
                    str_Where += "(t01_Vorname >= '" + .tx_91_Vorname_von.Text + "' and t01_Vorname <= '" + .tx_91_Vorname_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_Vorname Like '" + .tx_91_Vorname_von.Text + "%')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_GDat_TT_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_GDat_TT_bis.Text <> "" Then
                    str_Where += "(t01_GDat_TT >= '" + .tx_91_GDat_TT_von.Text + "' and t01_GDat_TT <= '" + .tx_91_GDat_TT_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_GDat_TT = '" + .tx_91_GDat_TT_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_GDat_MM_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_GDat_MM_bis.Text <> "" Then
                    str_Where += "(t01_GDat_MM >= '" + .tx_91_GDat_MM_von.Text + "' and t01_GDat_MM <= '" + .tx_91_GDat_MM_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_GDat_MM = '" + .tx_91_GDat_MM_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_GDat_JJ_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_GDat_JJ_bis.Text <> "" Then
                    str_Where += "(t01_GDat_JJ >= '" + .tx_91_GDat_JJ_von.Text + "' and t01_GDat_JJ <= '" + .tx_91_GDat_JJ_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_GDat_JJ = '" + .tx_91_GDat_JJ_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_GOrt_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_GOrt_bis.Text <> "" Then
                    str_Where += "(t01_GOrt >= '" + .tx_91_GOrt_von.Text + "' and t01_GOrt <= '" + .tx_91_GOrt_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_GOrt = '" + .tx_91_GOrt_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_SDat_TT_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_SDat_TT_bis.Text <> "" Then
                    str_Where += "(t01_SDat_TT >= '" + .tx_91_SDat_TT_von.Text + "' and t01_SDat_TT <= '" + .tx_91_SDat_TT_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_SDat_TT = '" + .tx_91_SDat_TT_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_SDat_MM_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_SDat_MM_bis.Text <> "" Then
                    str_Where += "(t01_SDat_MM >= '" + .tx_91_SDat_MM_von.Text + "' and t01_SDat_MM <= '" + .tx_91_SDat_MM_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_SDat_MM = '" + .tx_91_SDat_JJ_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_SDat_JJ_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_SDat_JJ_bis.Text <> "" Then
                    str_Where += "(t01_SDat_JJ >= '" + .tx_91_SDat_JJ_von.Text + "' and t01_SDat_JJ <= '" + .tx_91_SDat_JJ_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_SDat_JJ = '" + .tx_91_SDat_JJ_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_SOrt_von.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                If .tx_91_SOrt_bis.Text <> "" Then
                    str_Where += "(t01_SOrt >= '" + .tx_91_SOrt_von.Text + "' and t01_SOrt <= '" + .tx_91_SOrt_bis.Text + "')"
                    AnzInp += 1
                Else
                    str_Where += "(t01_SOrt = '" + .tx_91_SOrt_von.Text + "')"
                    AnzInp += 1
                End If
            End If
            If .tx_91_Geschlecht.Text <> "" Then
                If AnzInp > 0 Then str_Where += " and "
                str_Where += "(t01_Geschl = '" + .tx_91_Geschlecht.Text + "')"
                AnzInp += 1
            End If
        End With
    End Sub

End Class
