﻿Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.Cls_90_Mask_201
Public Class Cls_91_DB_Para_07

    REM ***********************************************************
    REM *  Bearbeitung Tabelle 08 (Namen)                         *
    REM ***********************************************************
    Public Shared Sub Para_Namen_Load()
        Dim int_i5 As Integer
        int_AnzNam1 = GetNumberOfRecords(con, "a07_Namen")
        With NM_Ahnen_Para
            .dgv_Name.Rows.Clear()
            For int_i5 = 1 To int_AnzNam1
                .dgv_Name.Rows.Add(int_i5.ToString("0000"), str_Para_Nam1_Text(int_i5), int_Anz_Name(int_i5, 0), int_Anz_Name(int_i5, 1), int_Anz_Name(int_i5, 2), int_Anz_Name(int_i5, 3))
            Next
            .dgv_Name.Sort(.dgv_Name.Columns(1), System.ComponentModel.ListSortDirection.Ascending)
        End With
    End Sub

    REM **************************************************************
    REM *  Maskenfelder für Neuanlage leeren                         *
    REM **************************************************************
    Public Shared Sub Para_Namen_Neu()
        With NM_Ahnen_Para
            int_AnzNam1 += 1
            .tx_201_Z1.Text = ""
        End With
    End Sub

    REM ***************************************************************
    REM *  Neuen Eintrag in DB eintragen                              *
    REM ***************************************************************
    Public Shared Sub Para_Namen_Insert()
        Dim int_Hanz As Integer = 0
        Call DB_Tab_High("a07_ID", "a07_Namen")
        dbl_Max_ID += 1
        NM_Ahnen_Para.tx_201_Z1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z1.Text)
        str_DBD_a07 = " values ('" + dbl_Max_ID.ToString + "'"
        str_DBD_a07 += "'" + NM_Ahnen_Para.tx_201_Z1.Text + "',"
        str_DBD_a07 += "'" + int_Hanz.ToString + "',"
        str_DBD_a07 += "'" + int_Hanz.ToString + "',"
        str_DBD_a07 += "'" + int_Hanz.ToString + "',"
        str_DBD_a07 += "'" + int_Hanz.ToString + "')"
        str_Tab = str_DBS_a07 + str_DBD_a07
        mySelect.CommandText = "insert into a07_Namen " & str_Tab
        Call DB_Execute()
        Call Tab_Namen()
        Call Para_Namen_Load()
    End Sub

    REM *****************************************************************
    REM *  Änderung in Datenbank übertragen                             *
    REM *****************************************************************
    Public Shared Sub Para_Namen_Update()
        Dim reader As OleDbDataReader
        Dim int_a07_Typ As Integer = 1
        Dim int_i88 As Integer
        With NM_Ahnen_Para
            .tx_201_Z1.Text = .dgv_Name.CurrentRow.Cells(1).Value
            For int_i88 = 0 To int_AnzNam1
                If .tx_201_Z1.Text = str_Para_Nam1_Text(int_i88) Then
                    dbl_x = int_Para_Nam1_Nr(int_i88)
                    Exit For
                End If
            Next
        End With
        mySelect.CommandText = "select * from a07_Namen"
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a07_ID"))
                If myNull = False Then dbl_x = reader.Item("a07_ID")
            Loop
            reader.Close()
        Catch ex As Exception

        End Try
    End Sub

    REM ***********************************************************
    REM *  Update ausführen                                       *
    REM ***********************************************************
    Public Shared Sub Para_Namen_Update2()
        str_Tab = "a07_Text = '" + NM_Ahnen_Para.tx_201_Z1.Text + "'"
        mySelect.CommandText = "update a07_Namen set " & str_Tab & " where a07_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Namen()
        Call Para_Namen_Load()
    End Sub

    REM *************************************************************
    REM *  Namenstabelle komplett neu aufbauen                      *
    REM *************************************************************
    Public Shared Sub Para_Namen_Aufbau()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Dim str_N1 As String
        Dim str_N2 As String
        Dim str_N3 As String
        Dim str_N4 As String
        ReDim str_Name(int_Anz * 2)
        ReDim int_Anz_Name(int_Anz * 2, 3)
        Dim reader As OleDbDataReader
        int_Anz_Ort = 1

        REM *  alte Werte löschen
        mySelect.CommandText = "delete * from a07_Namen"
        Call DB_Execute()
        mySelect.CommandText = "select * from t01_Person"
        reader = mySelect.ExecuteReader
        Do While reader.Read
            str_N1 = ""
            str_N2 = ""
            str_N3 = ""
            str_N4 = ""
            myNull = IsDBNull(reader.Item("t01_Name"))
            If myNull = False Then str_N1 = reader.Item("t01_Name")
            myNull = IsDBNull(reader.Item("t01_GebName"))
            If myNull = False Then str_N2 = reader.Item("t01_GebName")
            myNull = IsDBNull(reader.Item("t01_NameZ"))
            If myNull = False Then str_N3 = reader.Item("t01_NameZ")
            myNull = IsDBNull(reader.Item("t01_RufName"))
            If myNull = False Then str_N4 = reader.Item("t01_RufName")
            str_N1 = Trim(str_N1)
            str_N2 = Trim(str_N2)
            str_N3 = Trim(str_N3)
            str_N4 = Trim(str_N4)
            If str_N1 > "" Then Call Para_Namen_Tabelle(str_N1, 0)
            If str_N2 > "" Then Call Para_Namen_Tabelle(str_N2, 1)
            If str_N3 > "" Then Call Para_Namen_Tabelle(str_N3, 2)
            If str_N4 > "" Then Call Para_Namen_Tabelle(str_N4, 3)
        Loop
        reader.Close()
        Call Para_Namen_Aufbau_Insert()
    End Sub

    REM ***********************************************************
    REM *  Daten in Tabelle sammeln                               *
    REM ***********************************************************
    Public Shared Sub Para_Namen_Tabelle(ByVal str_NX As String, ByVal int_Typ As Integer)
        Dim i88 As Integer
        For i88 = 1 To int_Anz_Ort - 1
            If str_Name(i88) = str_NX Then
                int_Anz_Name(i88, int_Typ) += 1
                Exit Sub
            End If
        Next
        str_Name(int_Anz_Ort) = str_NX
        int_Anz_Ort += 1
    End Sub

    REM ***********************************************************
    REM *  Tabelle in DB übertragen                               *
    REM ***********************************************************
    Public Shared Sub Para_Namen_Aufbau_Insert()
        Dim int_i88 As Integer

        For int_i88 = 1 To int_Anz_Ort - 1
            str_Name(int_i88) = DB_ZeichenString(str_Name(int_i88))

            str_DBD_a07 = " values ('" + int_i88.ToString + "',"
            str_DBD_a07 += "'" + str_Name(int_i88).ToString + "',"
            str_DBD_a07 += "'" + int_Anz_Name(int_i88, 0).ToString + "',"
            str_DBD_a07 += "'" + int_Anz_Name(int_i88, 1).ToString + "',"
            str_DBD_a07 += "'" + int_Anz_Name(int_i88, 2).ToString + "',"
            str_DBD_a07 += "'" + int_Anz_Name(int_i88, 3).ToString + "')"
            str_Tab = str_DBS_a07 + str_DBD_a07
            mySelect.CommandText = "insert into a07_Namen " & str_Tab
            Call DB_Execute()
        Next
        Call Tab_Namen()
        Call Para_Namen_Load()
    End Sub

End Class
