﻿Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_02_DB_Person_Read
Imports NM_Ahnen.cls_03_DB_Person_Update
Imports NM_Ahnen.cls_03_DB_Person_Neu
Imports NM_Ahnen.cls_09_Mask_Person
Imports NM_Ahnen.cls_20_Blaettern
Imports NM_Ahnen.cls_30_Search
Imports NM_Ahnen.cls_50_Daten_10
Imports NM_Ahnen.cls_50_Daten_11
Imports NM_Ahnen.cls_50_Daten_12
Imports NM_Ahnen.cls_50_Daten_13
Imports NM_Ahnen.cls_50_Daten_14
Imports NM_Ahnen.cls_50_Daten_15
Imports NM_Ahnen.cls_50_Daten_16
Imports NM_Ahnen.cls_50_Daten_17
Imports NM_Ahnen.cls_91_DB_Para
Imports System.Drawing.Printing

Public Class Cls_05_Strukturen
    REM **************************************************************
    REM *  Definition der Datenstrukturen                            *
    REM **************************************************************
    Public Shared Sub DB_Struktur()

        str_DBS_a01 = "("
        str_DBS_a01 += "a01_ID, "
        str_DBS_a01 += "a01_Typ, "
        str_DBS_a01 += "a01_User, "
        str_DBS_a01 += "a01_Sprache, "
        str_DBS_a01 += "a01_Drucker, "
        str_DBS_a01 += "a01_Schrift, "
        str_DBS_a01 += "a01_aktID)"

        str_DBS_a02 = " ("
        str_DBS_a02 += "a02_ID, "
        str_DBS_a02 += "a02_Vater_Min, "
        str_DBS_a02 += "a02_Vater_Max, "
        str_DBS_a02 += "a02_Mutter_Min, "
        str_DBS_a02 += "a02_Mutter_Max, "
        str_DBS_a02 += "a02_Ehe_Min, "
        str_DBS_a02 += "a02_Ehe_Max, "
        str_DBS_a02 += "a02_Pate_Min, "
        str_DBS_a02 += "a02_Pate_Max, "
        str_DBS_a02 += "a02_Zeuge_Min, "
        str_DBS_a02 += "a02_Zeuge_Max) "

        str_DBS_a03 = "("
        str_DBS_a03 += "a03_ID, "
        str_DBS_a03 += "a03_Typ, "
        str_DBS_a03 += "a03_lfd, "
        str_DBS_a03 += "a03_Kurz, "
        str_DBS_a03 += "a03_Lang)"

        str_DBS_a04 = "("
        str_DBS_a04 += "a04_ID, "
        str_DBS_a04 += "a04_Typ, "
        str_DBS_a04 += "a04_lfd, "
        str_DBS_a04 += "a04_Ort1, "
        str_DBS_a04 += "a04_Ort2, "
        str_DBS_a04 += "a04_Ort3, "
        str_DBS_a04 += "a04_Anz0, "
        str_DBS_a04 += "a04_Anz1, "
        str_DBS_a04 += "a04_Anz2, "
        str_DBS_a04 += "a04_Anz3, "
        str_DBS_a04 += "a04_Anz4, "
        str_DBS_a04 += "a04_Anz5, "
        str_DBS_a04 += "a04_Anz6, "
        str_DBS_a04 += "a04_Anz7)"

        str_DBS_a05 = "("
        str_DBS_a05 += "a05_ID, "
        str_DBS_a05 += "a05_Sprache, "
        str_DBS_a05 += "a05_Maske, "
        str_DBS_a05 += "a05_FeldNr, "
        str_DBS_a05 += "a05_Feldbez)"

        str_DBS_a06 = "("
        str_DBS_a06 += "a06_ID, "
        str_DBS_a06 += "a06_Beruf, "
        str_DBS_a06 += "a06_Anzahl)"

        str_DBS_a07 = "("
        str_DBS_a07 += "a07_ID, "
        str_DBS_a07 += "a07_Text, "
        str_DBS_a07 += "a07_Anz0, "
        str_DBS_a07 += "a07_Anz1, "
        str_DBS_a07 += "a07_Anz2, "
        str_DBS_a07 += "a07_Anz3) "

        str_DBS_a08 = "("
        str_DBS_a08 += "a08_ID, "
        str_DBS_a08 += "a08_Text, "
        str_DBS_a08 += "a08_Anzahl)"

        str_DBS_a09 = "("
        str_DBS_a09 += "a09_ID, "
        str_DBS_a09 += "a09_Text, "
        str_DBS_a09 += "a09_Anzahl) "

        str_DBS_t01 = " ("
        str_DBS_t01 += "t01_ID, "
        str_DBS_t01 += "t01_Name, "
        str_DBS_t01 += "t01_GebName, "
        str_DBS_t01 += "t01_NameZ, "
        str_DBS_t01 += "t01_Vorname, "
        str_DBS_t01 += "t01_Rufname, "
        str_DBS_t01 += "t01_SpitzN, "
        str_DBS_t01 += "t01_Titel, "
        str_DBS_t01 += "t01_Geschl, "
        str_DBS_t01 += "t01_Vater, "
        str_DBS_t01 += "t01_Mutter, "
        str_DBS_t01 += "t01_GDat_TT, "
        str_DBS_t01 += "t01_GDat_MM, "
        str_DBS_t01 += "t01_GDat_JJ, "
        str_DBS_t01 += "t01_GDat, "
        str_DBS_t01 += "t01_GDat_Sort, "
        str_DBS_t01 += "t01_GDat_Art, "
        str_DBS_t01 += "t01_GOrt, "
        str_DBS_t01 += "t01_SDat_TT, "
        str_DBS_t01 += "t01_SDat_MM, "
        str_DBS_t01 += "t01_SDat_JJ, "
        str_DBS_t01 += "t01_SDat, "
        str_DBS_t01 += "t01_SDat_Sort, "
        str_DBS_t01 += "t01_SDat_Art, "
        str_DBS_t01 += "t01_SOrt, "
        str_DBS_t01 += "t01_Search_Name, "
        str_DBS_t01 += "t01_Search_GebName, "
        str_DBS_t01 += "t01_Search_SpitzN, "
        str_DBS_t01 += "t01_Search_NameZ, "
        str_DBS_t01 += "t01_NeuDat, "
        str_DBS_t01 += "t01_AendDat) "

        int_AnzDB = 34

        str_t91_Head(0) = "t01_ID"
        str_t91_Head(1) = "t01_Name"
        str_t91_Head(2) = "t01_GebName"
        str_t91_Head(3) = "t01_NameZ"
        str_t91_Head(4) = "t01_Vorname"
        str_t91_Head(5) = "t01_Rufname"
        str_t91_Head(6) = "t01_SpitzN"
        str_t91_Head(7) = "t01_Titel"
        str_t91_Head(8) = "t01_Geschl"
        str_t91_Head(9) = "t01_Vater"
        str_t91_Head(10) = "t01_Mutter"
        str_t91_Head(11) = "t01_GDat_TT"
        str_t91_Head(12) = "t01_GDat_MM"
        str_t91_Head(13) = "t01_GDat_JJ"
        str_t91_Head(14) = "t01_GDat"
        str_t91_Head(15) = "t01_GDat_Sort"
        str_t91_Head(16) = "t01_GDat_Art"
        str_t91_Head(17) = "t01_GOrt"
        str_t91_Head(20) = "t01_SDat_TT"
        str_t91_Head(21) = "t01_SDat_MM"
        str_t91_Head(22) = "t01_SDat_JJ"
        str_t91_Head(23) = "t01_SDat"
        str_t91_Head(24) = "t01_SDat_Sort"
        str_t91_Head(25) = "t01_SDat_Art"
        str_t91_Head(26) = "t01_SOrt"
        str_t91_Head(29) = "t01_Search_Name"
        str_t91_Head(30) = "t01_Search_GebName"
        str_t91_Head(31) = "t01_Search_SpitzN"
        str_t91_Head(32) = "t01_Search_NameZ"
        str_t91_Head(33) = "t01_NeuDat"
        str_t91_Head(34) = "t01_AendDat"

        str_DBS_t02 = " ("
        str_DBS_t02 += "t02_ID, "
        str_DBS_t02 += "t02_Konf, "
        str_DBS_t02 += "t02_TDat_TT, "
        str_DBS_t02 += "t02_TDat_MM, "
        str_DBS_t02 += "t02_TDat_JJ, "
        str_DBS_t02 += "t02_TDat, "
        str_DBS_t02 += "t02_TDat_Art, "
        str_DBS_t02 += "t02_TOrt, "
        str_DBS_t02 += "t02_TKirche, "
        str_DBS_t02 += "t02_TPriester, "
        str_DBS_t02 += "t02_FDat_TT, "
        str_DBS_t02 += "t02_FDat_MM, "
        str_DBS_t02 += "t02_FDat_JJ, "
        str_DBS_t02 += "t02_FDat, "
        str_DBS_t02 += "t02_FDat_Art, "
        str_DBS_t02 += "t02_FOrt, "
        str_DBS_t02 += "t02_FKirche, "
        str_DBS_t02 += "t02_FPriester, "
        str_DBS_t02 += "t02_Bemerk) "

        str_DBS_t03 = " ("
        str_DBS_t03 += "t03_ID, "
        str_DBS_t03 += "t03_BDat_TT, "
        str_DBS_t03 += "t03_BDat_MM, "
        str_DBS_t03 += "t03_BDat_JJ, "
        str_DBS_t03 += "t03_BDat, "
        str_DBS_t03 += "t03_BDat_Art, "
        str_DBS_t03 += "t03_BOrt, "
        str_DBS_t03 += "t03_BArt, "
        str_DBS_t03 += "t03_BPriester, "
        str_DBS_t03 += "t03_Friedhof, "
        str_DBS_t03 += "t03_Grablage, "
        str_DBS_t03 += "t03_Tod_Ursache, "
        str_DBS_t03 += "t03_Bemerk) "

        str_DBS_t04 = " ("
        str_DBS_t04 += "t04_ID, "
        str_DBS_t04 += "t04_Partner1, "
        str_DBS_t04 += "t04_Partner2, "
        str_DBS_t04 += "t04_FK_ID) "

        str_DBS_t041 = " ("
        str_DBS_t041 += "t041_ID, "
        str_DBS_t041 += "t041_Dat1_TT, "
        str_DBS_t041 += "t041_Dat1_MM, "
        str_DBS_t041 += "t041_Dat1_JJ, "
        str_DBS_t041 += "t041_Dat1, "
        str_DBS_t041 += "t041_Dat1_Art, "
        str_DBS_t041 += "t041_Ort1, "
        str_DBS_t041 += "t041_Beamter, "
        str_DBS_t041 += "t041_Dat2_TT, "
        str_DBS_t041 += "t041_Dat2_MM, "
        str_DBS_t041 += "t041_Dat2_JJ, "
        str_DBS_t041 += "t041_Dat2, "
        str_DBS_t041 += "t041_Dat2_Art, "
        str_DBS_t041 += "t041_Ort2, "
        str_DBS_t041 += "t041_Kirche, "
        str_DBS_t041 += "t041_Priester, "
        str_DBS_t041 += "t041_Dat3_TT, "
        str_DBS_t041 += "t041_Dat3_MM, "
        str_DBS_t041 += "t041_Dat3_JJ, "
        str_DBS_t041 += "t041_Dat3, "
        str_DBS_t041 += "t041_Dat3_Art, "
        str_DBS_t041 += "t041_Bemerkung) "

        str_DBS_t05 = " ("
        str_DBS_t05 += "t05_ID, "
        str_DBS_t05 += "t05_FK_t01, "
        str_DBS_t05 += "t05_Typ, "
        str_DBS_t05 += "t05_FK_Rolle) "

        str_DBS_t06 = " ("
        str_DBS_t06 += "t06_ID, "
        str_DBS_t06 += "t06_FK_t01, "
        str_DBS_t06 += "t06_Lfd, "
        str_DBS_t06 += "t06_Land, "
        str_DBS_t06 += "t06_ZIP, "
        str_DBS_t06 += "t06_Ort, "
        str_DBS_t06 += "t06_Strasse, "
        str_DBS_t06 += "t06_Dat_von, "
        str_DBS_t06 += "t06_Dat_bis, "
        str_DBS_t06 += "t06_Telefon1, "
        str_DBS_t06 += "t06_Telefon2, "
        str_DBS_t06 += "t06_Telefax, "
        str_DBS_t06 += "t06_Mail, "
        str_DBS_t06 += "t06_Homepage, "
        str_DBS_t06 += "t06_Komm) "

        str_DBS_t07 = " ("
        str_DBS_t07 += "t07_ID, "
        str_DBS_t07 += "t07_FK_t01, "
        str_DBS_t07 += "t07_Lfd, "
        str_DBS_t07 += "t07_Beruf_t77, "
        str_DBS_t07 += "t07_Dat_von, "
        str_DBS_t07 += "t07_Dat_bis, "
        str_DBS_t07 += "t07_Komm) "

        str_DBS_t08 = " ("
        str_DBS_t08 += "t08_ID, "
        str_DBS_t08 += "t08_a04_ID, "
        str_DBS_t08 += "t08_Event, "
        str_DBS_t08 += "t08_t01_ID, "
        str_DBS_t08 += "t08_Datum) "

        str_DBS_t09 = " ("
        str_DBS_t09 += "t09_ID, "
        str_DBS_t09 += "t09_FK_t01, "
        str_DBS_t09 += "t09_lfd, "
        str_DBS_t09 += "t09_Typ, "
        str_DBS_t09 += "t09_FileName, "
        str_DBS_t09 += "t09_Text) "

        str_DBS_t10 = " ("
        str_DBS_t10 += "t10_ID, "
        str_DBS_t10 += "t10_Komm01, "
        str_DBS_t10 += "t10_Komm02, "
        str_DBS_t10 += "t10_Komm03, "
        str_DBS_t10 += "t10_Komm04, "
        str_DBS_t10 += "t10_Komm05, "
        str_DBS_t10 += "t10_Komm06, "
        str_DBS_t10 += "t10_Komm07, "
        str_DBS_t10 += "t10_Komm08, "
        str_DBS_t10 += "t10_Komm09, "
        str_DBS_t10 += "t10_Komm10, "
        str_DBS_t10 += "t10_Komm11, "
        str_DBS_t10 += "t10_Komm12, "
        str_DBS_t10 += "t10_Komm13, "
        str_DBS_t10 += "t10_Komm14, "
        str_DBS_t10 += "t10_Komm15, "
        str_DBS_t10 += "t10_Komm16, "
        str_DBS_t10 += "t10_Komm17, "
        str_DBS_t10 += "t10_Komm18, "
        str_DBS_t10 += "t10_Komm19, "
        str_DBS_t10 += "t10_Komm20, "
        str_DBS_t10 += "t10_Komm21, "
        str_DBS_t10 += "t10_Komm22, "
        str_DBS_t10 += "t10_Komm23, "
        str_DBS_t10 += "t10_Komm24, "
        str_DBS_t10 += "t10_Komm25, "
        str_DBS_t10 += "t10_Komm26, "
        str_DBS_t10 += "t10_Komm27, "
        str_DBS_t10 += "t10_Komm28, "
        str_DBS_t10 += "t10_Komm29, "
        str_DBS_t10 += "t10_Komm30, "
        str_DBS_t10 += "t10_Komm31, "
        str_DBS_t10 += "t10_Komm32, "
        str_DBS_t10 += "t10_Komm33, "
        str_DBS_t10 += "t10_Komm34, "
        str_DBS_t10 += "t10_Komm35, "
        str_DBS_t10 += "t10_Komm36, "
        str_DBS_t10 += "t10_Komm37, "
        str_DBS_t10 += "t10_Komm38, "
        str_DBS_t10 += "t10_Komm39, "
        str_DBS_t10 += "t10_Komm40, "
        str_DBS_t10 += "t10_Komm41, "
        str_DBS_t10 += "t10_Komm42, "
        str_DBS_t10 += "t10_Komm43, "
        str_DBS_t10 += "t10_Komm44, "
        str_DBS_t10 += "t10_Komm45, "
        str_DBS_t10 += "t10_Komm46, "
        str_DBS_t10 += "t10_Komm47, "
        str_DBS_t10 += "t10_Komm48, "
        str_DBS_t10 += "t10_Komm49, "
        str_DBS_t10 += "t10_Komm50, "
        str_DBS_t10 += "t10_Komm51, "
        str_DBS_t10 += "t10_Komm52, "
        str_DBS_t10 += "t10_Komm53, "
        str_DBS_t10 += "t10_Komm54, "
        str_DBS_t10 += "t10_Komm55, "
        str_DBS_t10 += "t10_Komm56, "
        str_DBS_t10 += "t10_Komm57, "
        str_DBS_t10 += "t10_Komm58, "
        str_DBS_t10 += "t10_Komm59, "
        str_DBS_t10 += "t10_Komm60, "
        str_DBS_t10 += "t10_Komm61, "
        str_DBS_t10 += "t10_Komm62, "
        str_DBS_t10 += "t10_Komm63, "
        str_DBS_t10 += "t10_Komm64, "
        str_DBS_t10 += "t10_Komm65) "

        str_DBS_t11 = " ("
        str_DBS_t11 += "t11_ID, "
        str_DBS_t11 += "t11_FK_t01, "
        str_DBS_t11 += "t11_Typ, "
        str_DBS_t11 += "t11_Nummer, "
        str_DBS_t11 += "t11_Text) "

        str_DBS_t12 = " ("
        str_DBS_t12 += "t12_ID, "
        str_DBS_t12 += "t12_Text) "

        str_DBS_t13 = " ("
        str_DBS_t13 += "t13_ID, "
        str_DBS_t13 += "t13_ID_t01, "
        str_DBS_t13 += "t13_Art, "
        str_DBS_t13 += "t13_Typ, "
        str_DBS_t13 += "t13_Event, "
        str_DBS_t13 += "t13_Ort, "
        str_DBS_t13 += "t13_KB, "
        str_DBS_t13 += "t13_Detail, "
        str_DBS_t13 += "t13_Quelle, "
        str_DBS_t13 += "t13_Datum, "
        str_DBS_t13 += "t13_Bemerkung) "

        str_DBS_t21 = " ("
        str_DBS_t21 += "t21_ID, "
        str_DBS_t21 += "t21_SB, "
        str_DBS_t21 += "t21_FK_t01) "

        str_DBS_t31 = " ("
        str_DBS_t31 += "t31_ID, "
        str_DBS_t31 += "t31_Bezeichnung, "
        str_DBS_t31 += "t31_Kurz) "

        str_DBS_t32 = " ("
        str_DBS_t32 += "t32_ID, "
        str_DBS_t32 += "t32_Ort, "
        str_DBS_t32 += "t32_Bemerkung) "

        str_DBS_t33 = " ("
        str_DBS_t33 += "t33_ID, "
        str_DBS_t33 += "t33_Detail, "
        str_DBS_t33 += "t33_Bemerkung) "

        str_DBS_t77 = " ("
        str_DBS_t77 += "t77_ID, "
        str_DBS_t77 += "t77_Beruf) "

        str_DBS_t88 = " ("
        str_DBS_t88 += "t88_ID, "
        str_DBS_t88 += "t88_FK_t01, "
        str_DBS_t88 += "t88_Tab, "
        str_DBS_t88 += "t88_Feld, "
        str_DBS_t88 += "t88_Datum, "
        str_DBS_t88 += "t88_text) "

        str_DBS_t92 = " ("
        str_DBS_t92 += "t92_ID, "
        str_DBS_t92 += "t92_FK_t01, "
        str_DBS_t92 += "t92_Kekule, "
        str_DBS_t92 += "t92_Name, "
        str_DBS_t92 += "t92_Vorname, "
        str_DBS_t92 += "t92_Gen_Stufe, "
        str_DBS_t92 += "t92_GDat, "
        str_DBS_t92 += "t92_SDat, "
        str_DBS_t92 += "t92_Vater, "
        str_DBS_t92 += "t92_Mutter, "
        str_DBS_t92 += "t92_VGrad, "
        str_DBS_t92 += "t92_Partner_ID, "
        str_DBS_t92 += "t92_Geschlecht, "
        str_DBS_t92 += "t92_Res1, "
        str_DBS_t92 += "t92_Res2, "
        str_DBS_t92 += "t92_Res3) "

        str_DBS_t99 = " ("
        str_DBS_t99 += "t99_ID, "
        str_DBS_t99 += "t99_FK_t01, "
        str_DBS_t99 += "t99_LFD, "
        str_DBS_t99 += "t99_Name, "
        str_DBS_t99 += "t99_GebName, "
        str_DBS_t99 += "t99_Vorname, "
        str_DBS_t99 += "t99_GDat, "
        str_DBS_t99 += "t99_TabIndex, "
        str_DBS_t99 += "t99_FeldNr, "
        str_DBS_t99 += "t99_Aktion) "

    End Sub


    REM **************************************************************
    REM *  Tabelle für Feldbezeichnungen (Historie) füllen           *
    REM **************************************************************
    Public Shared Sub Tab_FeldBez()

        Dim i66 As Integer
        Dim i67 As Integer

        For i66 = 0 To 7
            str_Tab_Text(i66) = ""
            For i67 = 0 To 25
                str_Feld_Text(i66, i67) = ""
            Next i67
        Next i66
        str_Tab_Text(0) = "Basis"
        str_Tab_Text(1) = "Taufe"
        str_Tab_Text(2) = "Beerd."
        str_Tab_Text(3) = "Ehe"
        str_Tab_Text(4) = "Adresse"
        str_Tab_Text(5) = "Berufe"
        str_Tab_Text(6) = "Text"
        str_Tab_Text(7) = "Paten/Zeugen"

        str_Feld_Text(0, 1) = "Name"
        str_Feld_Text(0, 2) = "Geburtsname"
        str_Feld_Text(0, 3) = "Zusatzname"
        str_Feld_Text(0, 4) = "Vorname"
        str_Feld_Text(0, 5) = "Rufname"
        str_Feld_Text(0, 6) = "Spitzname"
        str_Feld_Text(0, 7) = "Titel"
        str_Feld_Text(0, 8) = "Geschlecht"
        str_Feld_Text(0, 9) = "Vater"
        str_Feld_Text(0, 10) = "Mutter"
        str_Feld_Text(0, 11) = "Geb.datum"
        str_Feld_Text(0, 12) = "Datumsart"
        str_Feld_Text(0, 13) = "Geb.Ort"
        str_Feld_Text(0, 14) = "Geb.Urk (Kirche)"
        str_Feld_Text(0, 15) = "Geb.Urk (Stand.)"
        str_Feld_Text(0, 16) = "Sterbedatum"
        str_Feld_Text(0, 17) = "Datumsart"
        str_Feld_Text(0, 18) = "Sterbeort"
        str_Feld_Text(0, 19) = "Sterbeurk (Kirche)"
        str_Feld_Text(0, 20) = "Sterbeurk (Stand.)"

        str_Feld_Text(1, 1) = "Taufdatum"
        str_Feld_Text(1, 2) = "Datumsart"
        str_Feld_Text(1, 3) = "Taufort"
        str_Feld_Text(1, 4) = "Taufkirche"
        str_Feld_Text(1, 5) = "Konfession"
        str_Feld_Text(1, 6) = "Priester"
        str_Feld_Text(1, 7) = "Taufurk"
        str_Feld_Text(1, 8) = "Taufpaten"
        str_Feld_Text(1, 9) = ""
        str_Feld_Text(1, 10) = ""
        str_Feld_Text(1, 11) = ""
        str_Feld_Text(1, 15) = "Komm.datum"
        str_Feld_Text(1, 16) = "Datumsart"
        str_Feld_Text(1, 17) = "Komm.Ort"
        str_Feld_Text(1, 18) = "Komm.Kirche"
        str_Feld_Text(1, 19) = "Priester"
        str_Feld_Text(1, 20) = "Komm.Urkunde"
        str_Feld_Text(1, 21) = "Bemerkung"

        str_Feld_Text(2, 1) = "Beerd.Datum"
        str_Feld_Text(2, 1) = "Datumsart"
        str_Feld_Text(2, 3) = "Beerd.Ort"
        str_Feld_Text(2, 4) = "Bestatt.Art"
        str_Feld_Text(2, 5) = "Priester"
        str_Feld_Text(2, 6) = "Friedhof"
        str_Feld_Text(2, 7) = "Grablage"
        str_Feld_Text(2, 8) = "Todesursache"
        str_Feld_Text(2, 9) = "Sterbeurkunde (Kirche)"
        str_Feld_Text(2, 10) = "Sterbeurkunde (Stand.)"

        str_Feld_Text(3, 1) = "Ehe.Datum 1"
        str_Feld_Text(3, 2) = "Datumsart"
        str_Feld_Text(3, 3) = "Ehe.Ort "
        str_Feld_Text(3, 4) = "Beamter"
        str_Feld_Text(3, 5) = "Ehe.Urkunde 1"
        str_Feld_Text(3, 6) = "Ehe.Datum 2"
        str_Feld_Text(3, 7) = "Datumsart"
        str_Feld_Text(3, 8) = "Ehe.Ort2"
        str_Feld_Text(3, 9) = "Priester"
        str_Feld_Text(3, 10) = "Ehe.Urkunde 2"
        str_Feld_Text(3, 11) = "Ehe.Datum 3"
        str_Feld_Text(3, 12) = "Ehe.Datumsart"
        str_Feld_Text(3, 13) = "Ehe.Urkunde 3"
        str_Feld_Text(3, 14) = "Ehe.Bemerk"

        str_Feld_Text(4, 1) = "Land"
        str_Feld_Text(4, 2) = "PLZ"
        str_Feld_Text(4, 3) = "Ort"
        str_Feld_Text(4, 4) = "Strasse"
        str_Feld_Text(4, 5) = "Dat.von"
        str_Feld_Text(4, 6) = "Dat.bis"
        str_Feld_Text(4, 7) = "Tel 1"
        str_Feld_Text(4, 8) = "Tel 2"
        str_Feld_Text(4, 9) = "Fax"
        str_Feld_Text(4, 10) = "Mail"
        str_Feld_Text(4, 11) = "Homepage"

    End Sub
End Class
