﻿Imports System.Windows.Forms
Imports System.Drawing
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_10_Mask_01
Imports NM_Ahnen.cls_10_Mask_10
Imports NM_Ahnen.cls_10_Mask_11
Imports NM_Ahnen.cls_10_Mask_12
Imports NM_Ahnen.cls_10_Mask_13
Imports NM_Ahnen.cls_10_Mask_14
Imports NM_Ahnen.cls_10_Mask_15
Imports NM_Ahnen.cls_10_Mask_16
Imports NM_Ahnen.cls_10_Mask_17
Imports NM_Ahnen.Cls_80_Mask_91
Imports NM_Ahnen.Cls_90_Mask_201
Imports NM_Ahnen.Cls_90_Mask_Quelle

REM *****************************************************************
REM *  Grundklasse für alle Maskenfelder und -größen                *
REM *****************************************************************
Class Cls_10_Mask
    Public Shared Sub Mask_Pos()
        int_Screen_W = 1920
        int_Screen_H = 1080
        If int_Monitor = 2 Then int_Screen_W = 1280 : int_Screen_H = 720
        If int_Monitor = 3 Then int_Screen_W = 1024 : int_Screen_H = 768
        NM_Ahnen.Width = int_Screen_W
        NM_Ahnen.Height = int_Screen_H
        NM_Ahnen.Location = New System.Drawing.Point(int_Screen_x, int_Screen_y)

        font_Foretext = font_Foretext_Big
        font_Foretext_Bold = font_Foretext_Bold_Big
        font_Label = font_Label_Big
        int_Navi_Height = int_Navi_Height_Big
        int_pan_Height = int_pan_Height_Big
        int_txt_Height = int_txt_Height_Big
        int_txt2_Height = int_txt2_Height_Big
        int_lbl_Height = int_lbl2_Height_Big
        int_lbl2_Height = int_lbl2_Height_Big
        int_gbx_Height = int_gbx_Height_Big
        int_gbx91_Height = int_gbx91_Height_Big
        int_lbx_Height = int_lbx_Height_Big
        int_tab_Height = int_tab_Height_Big
        int_gbx3_Height = int_gbx3_Height_Big
        int_ZDiff = int_ZDiff_Big
        int_BDiff = int_BDiff_Big
        int_RB_Loc = int_RB_Loc_Big
        int_GridZeileH = int_GridZeileH_Big

        If int_Monitor > 1 Then
            font_Foretext = font_Foretext_1024
            font_Foretext_Bold = font_Foretext_Bold_1024
            font_Label = font_Label_1024
            'int_Navi_Height = int_Navi_Height_Low
            int_pan_Height = int_pan_Height_Low
            int_txt_Height = int_txt_Height_Low
            int_txt2_Height = int_txt2_Height_Low
            int_lbl_Height = int_lbl2_Height_Low
            int_lbl2_Height = int_lbl2_Height_Low
            int_pan_Height = int_pan_Height_Low
            int_gbx_Height = int_gbx_Height_Low
            int_gbx91_Height = int_gbx91_Height_Low
            int_lbx_Height = int_lbx_Height_Low
            int_tab_Height = int_tab_Height_Low
            int_gbx3_Height = int_gbx3_Height_Low
            int_ZDiff = int_ZDiff_Low
            int_BDiff = int_BDiff_Low
            int_RB_Loc = int_RB_Loc_Low
            int_GridZeileH = int_GridZeileH_Low

        End If
        Call MaskDim()
        Call Mask_Menue()
        Call Mask_Navi()
        Call Mask_Pos_00()
        Call Mask_Pos_01()
        Call Mask_Pos_10()
        Call Mask_Pos_11()
        Call Mask_Pos_12()
        Call Mask_Pos_13()
        Call Mask_Pos_14()
        Call Mask_Pos_15()
        Call Mask_Pos_16()
        Call Mask_Pos_17()
        Call Mask_Pos_Status()
        Call Mask_Pos_91()
        Call Mask_Pos_201()
        Call Mask_Pos_Quelle()
    End Sub

    REM *****************************************************************
    REM *  Ermitteln der Maskengrößen anhand Bildschirmgrößen           *
    REM *****************************************************************
    Public Shared Sub MaskDim()
        int_SC_FormW = int_Screen_W
        int_SC_FormH = int_Screen_H
        REM *---------------------------------------------------*
        REM *  Höhenermittlung der Fensterteile                 *
        REM *  Gesamthöhe ist vom System vorgegeben (FULL)      *
        REM *---------------------------------------------------*
        int_pan_Height = int_SC_FormH - int_Menue_Height - int_Navi_Height - (int_Stst_Height * 3) - (int_BordW * 3)

        int_spc1_height = int_pan_Height - int_gbx_Height
        int_spc1_pan1_height = int_spc1_height - 20
        int_spc1_pan2_height = int_spc1_height - 20
        int_tab_Height = int_spc1_pan1_height - (int_BordW * 3)

        REM *---------------------------------------------------*
        REM *  Maskenkomponenten 01 (rechts)                    *
        REM *---------------------------------------------------*
        int_pan_01 = int_spc1_height - int_gbx_Height

        int_Vater_Height = int_lbl_Height * 3
        int_Mutter_Height = int_lbl_Height * 3

        int_Listbox_Gesamt_Height = int_pan_01 - int_Vater_Height - int_Mutter_Height
        int_Listbox_Gesamt_Height -= (int_lbl_Height * 6)
        int_lbx_Geschw_Height = int_Listbox_Gesamt_Height * 0.3
        int_lbx_Ehe_Height = int_Listbox_Gesamt_Height * 0.2
        int_lbx_Kinder_Height = int_Listbox_Gesamt_Height * 0.4

        int_lbx_Paten_Height = int_Listbox_Gesamt_Height * 0.2
        int_lbx_Zeugen_Height = int_Listbox_Gesamt_Height * 0.15
        int_rtx_Text_Height = int_Listbox_Gesamt_Height * 0.9

        REM *---------------------------------------------------*
        REM *  Breitenermittlung der Fensterteile               *
        REM *  Gesamthöhe ist vom System vorgegeben (FULL)      *
        REM *---------------------------------------------------*
        int_Navi_Width = int_SC_FormW
        int_Stst_Width = int_SC_FormW
        int_pan_Width = int_SC_FormW

        int_spc1_width = int_pan_Width
        int_spc1_pan1_width = (int_spc1_width - (int_BordW * 2)) / 2
        int_spc1_pan2_width = (int_spc1_width - (int_BordW * 2)) / 2

        int_tb1_Width = int_spc1_pan1_width

        int_SplitDisW = int_spc1_pan1_width + int_SplitDisP
        int_gbx_Width = int_spc1_pan1_width - 20

        int_lbl_Width = (int_spc1_pan1_width - 20) / 6
        int_txt_Width = int_lbl_Width * 4
        int_txt1_Width = int_txt_Width
        int_txt2_Width = int_txt_Width / 2
        int_txt3_width = int_txt_Width / 3
        int_txt4_Width = int_txt_Width / 4
        int_txt5_Width = int_txt_Width / 5
        int_txt6_Width = int_txt_Width / 6

        int_DatTT_Width = int_lbl_Width / 100 * 20
        int_DatMM_Width = int_lbl_Width / 100 * 20
        int_DatJJ_Width = int_lbl_Width / 100 * 44
        int_DatP_Width = int_lbl_Width / 100 * 7
        int_Dat_Height = int_txt_Height

        int_gbx_Width = int_lbl_Width + int_txt_Width
        int_lbx_Width_Rechts = int_lbl_Width + int_txt_Width + 55
        int_lbx_Width = int_lbl_Width + int_txt_Width

        int_rbt01_Height = 70
        int_rbt01_Width = int_spc1_pan2_width - 50

        int_tab_Width = int_spc1_pan2_width - 50
        int_tab_Height = int_spc1_pan2_height - 50

        int_91_Height = int_SC_FormH - 250
        int_91_Width = int_SC_FormW - 450
        int_gbx91_Width = int_91_Width - 50
        int_gbx91_Height = int_lbl_Height * 11

        int_Grid_W = int_gbx91_Width
        int_Grid_H = int_91_Height - 340
    End Sub

    REM *************************************************************
    REM *  Größenübertragung der Maskengrundelemente                *
    REM *************************************************************
    Public Shared Sub Mask_Pos_00()
        With NM_Ahnen
            .pan_Daten.Location = New System.Drawing.Point(5, 5 + int_Navi_Height + int_Menue_Height)
            .pan_Daten.Height = int_pan_Height
            .pan_Daten.Width = int_pan_Width

            'SplitContainer1
            .spc1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
            .spc1.Location = New System.Drawing.Point(1, 5 + int_Navi_Height + int_Menue_Height)
            .spc1.Size = New System.Drawing.Size(int_spc1_width, int_spc1_height)
            .spc1.SplitterDistance = int_SplitDisW
            'SplitContainer1.Panel1
            .spc1.Panel1.BackColor = col_Back
            .spc1.Panel1.Location = New System.Drawing.Point(1, 1)

            .pan_OK.Location = New System.Drawing.Point(int_tab_Width - (int_Navi_Button_Width * 5) - (int_BordW * 3), int_tab_Height + int_BordW)
            .pan_OK.MinimumSize = New System.Drawing.Size((int_Navi_Button_Width * 3), int_gbx_Height)
            .pan_OK.Size = New System.Drawing.Size((int_Navi_Button_Width * 3), int_gbx_Height)
            .pan_OK.Visible = False

            Dim int_Navi_OK As Integer = int_Navi_Button_Width
            int_Pos_x = 10
            int_Pos_y = 5
            .bt_xx_OK.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_xx_OK.BackColor = col_btn
            .bt_xx_OK.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_xx_OK.MinimumSize = New System.Drawing.Size(int_Navi_OK, int_Navi_OK)
            .bt_xx_OK.Size = New System.Drawing.Size(int_Navi_OK, int_Navi_OK)
            .bt_xx_OK.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            .bt_xx_OK.Visible = True

            int_Pos_x = 10 + (int_Navi_OK + (int_Navi_OK / 2))
            .bt_xx_Cancel.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_xx_Cancel.BackColor = col_btn
            .bt_xx_Cancel.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_xx_Cancel.MinimumSize = New System.Drawing.Size(int_Navi_OK, int_Navi_OK)
            .bt_xx_Cancel.Size = New System.Drawing.Size(int_Navi_OK, int_Navi_OK)
            .bt_xx_Cancel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            .bt_xx_Cancel.Visible = True


            .gbx_01_Person.Location = New System.Drawing.Point(10, 1)
            .gbx_01_Person.MinimumSize = New System.Drawing.Size(int_gbx_Width - 25, int_gbx_Height)
            .gbx_01_Person.Size = New System.Drawing.Size(int_gbx_Width - 25, int_gbx_Height)

            .lbx_01_Person.Location = New System.Drawing.Point(3, 12)
            .lbx_01_Person.BorderStyle = System.Windows.Forms.BorderStyle.None
            .lbx_01_Person.Font = font_Header_Person
            .lbx_01_Person.MinimumSize = New System.Drawing.Size(int_gbx_Width - 30, int_gbx_Height - 20)
            .lbx_01_Person.Size = New System.Drawing.Size(int_gbx_Width - 30, int_gbx_Height - 20)
            .lbx_01_Person.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Dim int_Item_Width As Integer = (int_tab_Width - 20) / 8
            Dim int_Item_Height As Integer = 20
            .tb1.Location = New System.Drawing.Point(10, 10 + int_gbx_Height)
            .tb1.MinimumSize = New System.Drawing.Size(int_tab_Width, int_tab_Height)
            .tb1.Size = New System.Drawing.Size(int_tb1_Width, int_tab_Height)
            .tb1.SizeMode = TabSizeMode.Fixed
            .tb1.ItemSize = New Size(int_Item_Width, int_Item_Height)
            .tb1.Font = font_Foretext

            .gbx_01_Ansicht.Location = New System.Drawing.Point(10, 1)
            .gbx_01_Ansicht.MinimumSize = New System.Drawing.Size(int_gbx_Width, int_gbx_Height)
            .gbx_01_Ansicht.Size = New System.Drawing.Size(int_gbx_Width, int_gbx_Height)

            'SplitContainer1.Panel2
            .spc1.Panel2.BackColor = col_Back
            .spc1.Panel2.Location = New System.Drawing.Point(1, 1)

            .rb_01_Daten.Location = New System.Drawing.Point(30, int_RB_Loc)
            .rb_01_Pic.Location = New System.Drawing.Point(120, int_RB_Loc)
        End With
    End Sub
    REM ******************************************************************
    REM *  Positionieren des Menü-Strips                                 *
    REM ******************************************************************
    Public Shared Sub Mask_Menue()
        int_Pos_x = 0
        int_Pos_y = 1
        With NM_Ahnen
            .MenuStrip.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
        End With
    End Sub

    REM ******************************************************************
    REM *  Positionieren der Navi-Button                                 *
    REM ******************************************************************
    Public Shared Sub Mask_Navi()
        int_Pos_y = 20 + int_Menue_Height
        With NM_Ahnen
            .pan_Navi.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .pan_Navi.Width = int_Navi_Width
            .pan_Navi.Height = int_Navi_Height

            REM *--------------------------------------------------------*
            REM *  Navi-Button für die linke Seite                       *
            REM *--------------------------------------------------------*
            int_Pos_y = 15
            Call Navi_Pos_L(1)
            .bt_00_DB.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_DB.BackColor = col_btn
            .bt_00_DB.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            '.bt_00_DB.FlatAppearance.MouseDownBackColor = col_btn_Mouse
            .bt_00_DB.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_DB.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_DB.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(2)
            .bt_00_List.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_List.BackColor = col_btn
            .bt_00_List.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_List.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_List.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_List.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(3)
            .bt_00_Search.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Search.BackColor = Color.Transparent
            .bt_00_Search.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Search.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Search.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Search.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(4)
            .bt_00_Para.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Para.BackColor = col_btn
            .bt_00_Para.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Para.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Para.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Para.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(5)
            .bt_00_Todo.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Todo.BackColor = col_btn
            .bt_00_Todo.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Todo.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Todo.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Todo.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(6)
            .bt_00_His.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_His.BackColor = col_btn
            .bt_00_His.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_His.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_His.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_His.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(7)
            .bt_00_Orte.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Orte.BackColor = col_btn
            .bt_00_Orte.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Orte.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Orte.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Orte.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_L(8)
            .bt_00_Quelle.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Quelle.BackColor = col_btn
            .bt_00_Quelle.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Quelle.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Quelle.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            REM *--------------------------------------------------------*
            REM *  Navi-Button für die rechte Seite                      *
            REM *--------------------------------------------------------*
            Call Navi_Pos_R(8)
            .lbl_00_ID.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .lbl_00_ID.BackColor = col_lbl
            .lbl_00_ID.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
            .lbl_00_ID.Font = font_Label
            .lbl_00_ID.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .lbl_00_ID.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .lbl_00_ID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            .tx_00_ID.Location = New System.Drawing.Point(int_Pos_x + int_Navi_Button_Width, int_Pos_y)
            .tx_00_ID.BackColor = col_txt
            .tx_00_ID.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
            '.tx_00_ID.Font = font_Foretext
            .tx_00_ID.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width * 2, int_Navi_Button_Height)
            .tx_00_ID.Size = New System.Drawing.Size(int_Navi_Button_Width * 2, int_Navi_Button_Height)
            '.tx_00_ID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            .bt_00_ID.Location = New System.Drawing.Point(int_Pos_x + (int_Navi_Button_Width * 3), int_Pos_y)
            .bt_00_ID.BackColor = col_btn
            .bt_00_ID.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_ID.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_ID.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_ID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_R(1)
            .bt_00_First.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_First.BackColor = col_btn
            .bt_00_First.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_First.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_First.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_First.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_R(2)
            .bt_00_Before.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Before.BackColor = col_btn
            .bt_00_Before.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Before.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Before.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Before.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_R(3)
            .bt_00_Next.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Next.BackColor = col_btn
            .bt_00_Next.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Next.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Next.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Next.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_R(4)
            .bt_00_Last.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Last.BackColor = col_btn
            .bt_00_Last.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Last.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Last.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Last.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            Call Navi_Pos_R(6)
            .bt_00_Neu.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Neu.BackColor = Color.Transparent
            .bt_00_Neu.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Neu.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Neu.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Neu.TextAlign = System.Drawing.ContentAlignment.BottomCenter

            Call Navi_Pos_R(7)
            .bt_00_Del.Location = New System.Drawing.Point(int_Pos_x, int_Pos_y)
            .bt_00_Del.BackColor = col_btn
            .bt_00_Del.FlatAppearance.MouseOverBackColor = col_btn_Mouse
            .bt_00_Del.MinimumSize = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Del.Size = New System.Drawing.Size(int_Navi_Button_Width, int_Navi_Button_Height)
            .bt_00_Del.TextAlign = System.Drawing.ContentAlignment.BottomCenter
        End With
    End Sub
    Public Shared Sub Navi_Pos_L(ByVal i01 As Integer)
        int_Pos_x = 10 + ((i01 - 1) * int_Navi_Button_Width) + ((i01 - 1) * int_BDiff)
    End Sub
    Public Shared Sub Navi_Pos_R(ByVal i01 As Integer)
        int_Pos_x = int_SplitDisW + ((i01 - 1) * int_Navi_Button_Width) + ((i01 - 1) * int_BDiff)
    End Sub
    REM ******************************************************************
    REM *  Anzeige der Statuszeile                                       *
    REM *  die einzelnen Elemente werden prozentual bemaßt               *
    REM ******************************************************************
    Public Shared Sub Mask_Pos_Status()
        Dim dbl_W1_Proz As Double = 12.0
        Dim dbl_W2_Proz As Double = 7.0
        Dim dbl_W3_Proz As Double = 12.0
        Dim dbl_W4_Proz As Double = 10.0
        Dim dbl_W5_Proz As Double = 10.0
        Dim dbl_W6_Proz As Double = 10.0
        Dim dbl_W7_Proz As Double = 10.0
        Dim dbl_W8_Proz As Double = 7.0
        Dim dbl_W9_Proz As Double = 7.0
        Dim dbl_W10_Proz As Double = 7.0
        Dim dbl_W11_Proz As Double = 7.0
        Dim dbl_W12_Proz As Double = 12.0
        Dim dbl_W As Integer
        Dim int_WG As Integer = int_Screen_W

        With NM_Ahnen
            .Stat1.Location = New System.Drawing.Point(0, int_Screen_H - 50)
            .Stat1.Size = New System.Drawing.Size(int_WG, int_Stst_Height)
            .Stat1.Width = int_Stst_Width
            .Stat1.Height = int_Stst_Height
            '
            dbl_W = int_WG * dbl_W1_Proz / 100
            .Stat1_Copyright.AutoSize = False
            .Stat1_Copyright.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat1_Copyright.Text = str_Copyright
            .Stat1_Copyright.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            dbl_W = int_WG * dbl_W2_Proz / 100
            .Stat1_Prog.AutoSize = False
            .Stat1_Prog.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat1_Prog.Text = str_Prog_Name
            .Stat1_Prog.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            dbl_W = int_WG * dbl_W3_Proz / 100
            .Stat1_Release.AutoSize = False
            .Stat1_Release.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat1_Release.Text = str_Prog_Rel
            .Stat1_Release.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            dbl_W = int_WG * dbl_W4_Proz / 100
            .Stat1_DB.AutoSize = False
            .Stat1_DB.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat1_DB.Text = str_DBName
            .Stat1_DB.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            dbl_W = int_WG * dbl_W5_Proz / 100
            .Stat1_Anzahl.AutoSize = False
            .Stat1_Anzahl.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat1_Anzahl.Text = "Anzahl:"
            .Stat1_Anzahl.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

            dbl_W = int_WG * dbl_W6_Proz / 100
            .Stat1_Datum.AutoSize = False
            .Stat1_Datum.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat1_Datum.Text = str_AktDatP
            .Stat1_Datum.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
            '
            dbl_W = int_WG * dbl_W7_Proz / 100
            .Stat1_Zeit.AutoSize = False
            .Stat1_Zeit.Size = New System.Drawing.Size(dbl_W, int_Stat_H2)
            .Stat1_Zeit.Text = TimeString
            .Stat1_Zeit.TextAlign = System.Drawing.ContentAlignment.MiddleLeft

        End With
    End Sub
    REM ******************************************************************
    REM *  Verstecken der Tabellenreiter für Tab1                        *
    REM ******************************************************************
    Public Shared Sub Tab1_Hidden()
        With NM_Ahnen
            .tb1.SizeMode = TabSizeMode.Fixed
            .tb1.ItemSize = New Size(0, 1)
            .tb1.Appearance = TabAppearance.Buttons
        End With
    End Sub
End Class
