﻿Imports System.Data.OleDb
Imports NM_Ahnen.cls_00_Def
Imports NM_Ahnen.cls_02_DB
Imports NM_Ahnen.cls_04_Util
Imports NM_Ahnen.Cls_90_Mask_201
Public Class Cls_91_DB_Para_09
    '******************************************************************************************
    '*  Verarbeitung Parameter Tabelle a09 (Vornamen)                                         *
    '****************************************************************************************** 
    Public Shared Sub Para_Vornamen_Aufbau()
        Dim int_Anz As Integer = GetNumberOfRecords(con, "t01_Person")
        Dim str_N1 As String
        ReDim str_Name(int_Anz)
        ReDim int_Para_Anzahl(int_Anz)
        Dim reader As OleDbDataReader
        int_Anz_Ort = 1

        REM *  alte Werte löschen
        mySelect.CommandText = "delete * from a09_Vornamen"
        Call DB_Execute()
        mySelect.CommandText = "select * from t01_Person"
        reader = mySelect.ExecuteReader
        Do While reader.Read
            str_N1 = ""
            myNull = IsDBNull(reader.Item("t01_Vorname"))
            If myNull = False Then str_N1 = reader.Item("t01_Vorname")
            myNull = IsDBNull(reader.Item("t01_GebName"))
            str_N1 = Trim(str_N1)
            If str_N1 > "" Then Call Para_Vornamen_Tabelle(str_N1)
        Loop
        reader.Close()
        Call Para_Vornamen_Aufbau_Insert()
    End Sub
    REM ***********************************************************
    REM *  Daten in Tabelle sammeln                               *
    REM ***********************************************************
    Public Shared Sub Para_Vornamen_Tabelle(ByVal str_NX As String)
        Dim i88 As Integer
        For i88 = 1 To int_Anz_Ort - 1
            If str_Name(i88) = str_NX Then
                int_Para_Anzahl(i88) += 1
                Exit Sub
            End If
        Next
        str_Name(int_Anz_Ort) = str_NX
        int_Para_Anzahl(i88) = 1
        int_Anz_Ort += 1
    End Sub
    Public Shared Sub Para_Vornamen_Aufbau_Insert()
        Dim int_i88 As Integer

        For int_i88 = 1 To int_Anz_Ort - 1
            str_Name(int_i88) = DB_ZeichenString(str_Name(int_i88))

            str_DBD_a09 = " values ('" + int_i88.ToString + "',"
            str_DBD_a09 += "'" + str_Name(int_i88).ToString + "',"
            str_DBD_a09 += "'" + int_Para_Anzahl(int_i88).ToString + "')"
            str_Tab = str_DBS_a09 + str_DBD_a09
            mySelect.CommandText = "insert into a09_Vornamen " & str_Tab
            Call DB_Execute()
        Next
        Call Tab_Vornamen()
        Call Para_Vornamen_Load()
    End Sub
    REM ************************************************************
    REM *  Vornamenwerte in DataGrid übertragen                    *
    REM ************************************************************
    Public Shared Sub Para_Vornamen_Load()
        Dim int_i5 As Integer
        With NM_Ahnen_Para
            .dgv_Vorname.Rows.Clear()
            For int_i5 = 1 To int_AnzNam2
                .dgv_Vorname.Rows.Add(int_i5.ToString("0000"), str_Para_Nam2_Text(int_i5), int_Para_Vorname_Anz(int_i5))
            Next
            .dgv_Vorname.Sort(.dgv_Vorname.Columns(1), System.ComponentModel.ListSortDirection.Ascending)
        End With
    End Sub

    REM *************************************************************
    REM *  Maske für Neuanlage leeren                               *
    REM *************************************************************
    Public Shared Sub Para_Vornamen_Neu()
        With NM_Ahnen_Para
            int_AnzNam2 += 1
            .tx_201_Z1.Text = ""
        End With
    End Sub

    REM **************************************************************
    REM *  Neuen Eintrag in DB einfügen                              *
    REM **************************************************************
    Public Shared Sub Para_Vornamen_Insert()
        Dim int_a09_Typ As Integer = 2
        Call DB_Tab_High("a09_ID", "a09_Vornamen")
        dbl_Max_ID += 1
        NM_Ahnen_Para.tx_201_Z1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z1.Text)
        str_DBD_a09 = " values ('" + dbl_Max_ID.ToString + "'"
        str_DBD_a09 += "'" + int_a09_Typ.ToString + "',"
        str_DBD_a09 += "'" + int_AnzNam1.ToString + "',"
        str_DBD_a09 += "'" + NM_Ahnen_Para.tx_201_Z1.Text + "')"
        str_Tab = str_DBS_a07 + str_DBD_a07
        mySelect.CommandText = "insert into a09_Vornamen " & str_Tab
        Call DB_Execute()
        Call Tab_Vornamen()
        Call Para_Vornamen_Load()
    End Sub

    REM *********************************************************
    REM *  Eintrag updaten                                      *
    REM *********************************************************
    Public Shared Sub Para_Vornamen_Update()
        Dim reader As OleDbDataReader
        Dim int_a09_Typ As Integer = 2
        Dim int_i88 As Integer
        With NM_Ahnen_Para
            .tx_201_Z1.Text = .dgv_Vorname.CurrentRow.Cells(1).Value
            For int_i88 = 0 To int_AnzNam1
                If .tx_201_Z1.Text = str_Para_Nam2_Text(int_i88) Then
                    dbl_x = int_Para_Nam2_Nr(int_i88)
                    Exit For
                End If
            Next
        End With
        str_Where = "a09_Typ = " + int_a09_Typ.ToString
        'str_Where += " and a09_lfd = " + dbl_x.ToString
        mySelect.CommandText = "select * from a09_Vornamen where " & str_Where
        Try
            reader = mySelect.ExecuteReader
            Do While reader.Read
                myNull = IsDBNull(reader.Item("a09_ID"))
                If myNull = False Then dbl_x = reader.Item("a09_ID")
            Loop
            reader.Close()
        Catch ex As Exception
        End Try
        Call Tab_Vornamen()
        Call Para_Vornamen_Load()
    End Sub

    REM *************************************************************
    REM *  Datensatz update in DB                                   *
    REM *************************************************************
    Public Shared Sub Para_Vornamen_Update2()
        NM_Ahnen_Para.tx_201_Z1.Text = DB_ZeichenString(NM_Ahnen_Para.tx_201_Z1.Text)
        str_Tab = "a09_Text = '" + NM_Ahnen_Para.tx_201_Z1.Text + "'"
        mySelect.CommandText = "update a09_Vornamen set " & str_Tab & " where a09_ID = " & dbl_x.ToString
        Call DB_Execute()
        Call Tab_Vornamen()
        Call Para_Vornamen_Load()
    End Sub

End Class
